// *** WARNING: this file was generated by test. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***

package com.pulumi.akamai;

import com.pulumi.core.Output;
import com.pulumi.core.annotations.Import;
import com.pulumi.exceptions.MissingRequiredPropertyException;
import java.lang.Integer;
import java.lang.String;
import java.util.Objects;
import java.util.Optional;
import javax.annotation.Nullable;


public final class AppSecApiRequestConstraintsArgs extends com.pulumi.resources.ResourceArgs {

    public static final AppSecApiRequestConstraintsArgs Empty = new AppSecApiRequestConstraintsArgs();

    /**
     * Action to be taken when the API request constraint is triggered
     * 
     */
    @Import(name="action", required=true)
    private Output<String> action;

    /**
     * @return Action to be taken when the API request constraint is triggered
     * 
     */
    public Output<String> action() {
        return this.action;
    }

    /**
     * Unique identifier of the API endpoint to which the constraint will be assigned
     * 
     */
    @Import(name="apiEndpointId")
    private @Nullable Output<Integer> apiEndpointId;

    /**
     * @return Unique identifier of the API endpoint to which the constraint will be assigned
     * 
     */
    public Optional<Output<Integer>> apiEndpointId() {
        return Optional.ofNullable(this.apiEndpointId);
    }

    /**
     * Unique identifier of the security configuration
     * 
     */
    @Import(name="configId", required=true)
    private Output<Integer> configId;

    /**
     * @return Unique identifier of the security configuration
     * 
     */
    public Output<Integer> configId() {
        return this.configId;
    }

    /**
     * Unique identifier of the security policy
     * 
     */
    @Import(name="securityPolicyId", required=true)
    private Output<String> securityPolicyId;

    /**
     * @return Unique identifier of the security policy
     * 
     */
    public Output<String> securityPolicyId() {
        return this.securityPolicyId;
    }

    private AppSecApiRequestConstraintsArgs() {}

    private AppSecApiRequestConstraintsArgs(AppSecApiRequestConstraintsArgs $) {
        this.action = $.action;
        this.apiEndpointId = $.apiEndpointId;
        this.configId = $.configId;
        this.securityPolicyId = $.securityPolicyId;
    }

    public static Builder builder() {
        return new Builder();
    }
    public static Builder builder(AppSecApiRequestConstraintsArgs defaults) {
        return new Builder(defaults);
    }

    public static final class Builder {
        private AppSecApiRequestConstraintsArgs $;

        public Builder() {
            $ = new AppSecApiRequestConstraintsArgs();
        }

        public Builder(AppSecApiRequestConstraintsArgs defaults) {
            $ = new AppSecApiRequestConstraintsArgs(Objects.requireNonNull(defaults));
        }

        /**
         * @param action Action to be taken when the API request constraint is triggered
         * 
         * @return builder
         * 
         */
        public Builder action(Output<String> action) {
            $.action = action;
            return this;
        }

        /**
         * @param action Action to be taken when the API request constraint is triggered
         * 
         * @return builder
         * 
         */
        public Builder action(String action) {
            return action(Output.of(action));
        }

        /**
         * @param apiEndpointId Unique identifier of the API endpoint to which the constraint will be assigned
         * 
         * @return builder
         * 
         */
        public Builder apiEndpointId(@Nullable Output<Integer> apiEndpointId) {
            $.apiEndpointId = apiEndpointId;
            return this;
        }

        /**
         * @param apiEndpointId Unique identifier of the API endpoint to which the constraint will be assigned
         * 
         * @return builder
         * 
         */
        public Builder apiEndpointId(Integer apiEndpointId) {
            return apiEndpointId(Output.of(apiEndpointId));
        }

        /**
         * @param configId Unique identifier of the security configuration
         * 
         * @return builder
         * 
         */
        public Builder configId(Output<Integer> configId) {
            $.configId = configId;
            return this;
        }

        /**
         * @param configId Unique identifier of the security configuration
         * 
         * @return builder
         * 
         */
        public Builder configId(Integer configId) {
            return configId(Output.of(configId));
        }

        /**
         * @param securityPolicyId Unique identifier of the security policy
         * 
         * @return builder
         * 
         */
        public Builder securityPolicyId(Output<String> securityPolicyId) {
            $.securityPolicyId = securityPolicyId;
            return this;
        }

        /**
         * @param securityPolicyId Unique identifier of the security policy
         * 
         * @return builder
         * 
         */
        public Builder securityPolicyId(String securityPolicyId) {
            return securityPolicyId(Output.of(securityPolicyId));
        }

        public AppSecApiRequestConstraintsArgs build() {
            if ($.action == null) {
                throw new MissingRequiredPropertyException("AppSecApiRequestConstraintsArgs", "action");
            }
            if ($.configId == null) {
                throw new MissingRequiredPropertyException("AppSecApiRequestConstraintsArgs", "configId");
            }
            if ($.securityPolicyId == null) {
                throw new MissingRequiredPropertyException("AppSecApiRequestConstraintsArgs", "securityPolicyId");
            }
            return $;
        }
    }

}
