// *** WARNING: this file was generated by test. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***

package com.pulumi.akamai;

import com.pulumi.akamai.AppSecConfigurationArgs;
import com.pulumi.akamai.Utilities;
import com.pulumi.akamai.inputs.AppSecConfigurationState;
import com.pulumi.core.Output;
import com.pulumi.core.annotations.Export;
import com.pulumi.core.annotations.ResourceType;
import com.pulumi.core.internal.Codegen;
import java.lang.Integer;
import java.lang.String;
import java.util.List;
import java.util.Optional;
import javax.annotation.Nullable;

@ResourceType(type="akamai:index/appSecConfiguration:AppSecConfiguration")
public class AppSecConfiguration extends com.pulumi.resources.CustomResource {
    /**
     * Unique identifier of the new security configuration
     * 
     */
    @Export(name="configId", refs={Integer.class}, tree="[0]")
    private Output<Integer> configId;

    /**
     * @return Unique identifier of the new security configuration
     * 
     */
    public Output<Integer> configId() {
        return this.configId;
    }
    /**
     * Unique identifier of the Akamai contract associated with the new configuration
     * 
     */
    @Export(name="contractId", refs={String.class}, tree="[0]")
    private Output<String> contractId;

    /**
     * @return Unique identifier of the Akamai contract associated with the new configuration
     * 
     */
    public Output<String> contractId() {
        return this.contractId;
    }
    /**
     * Unique identifier of the existing configuration being cloned to create the new configuration
     * 
     */
    @Export(name="createFromConfigId", refs={Integer.class}, tree="[0]")
    private Output</* @Nullable */ Integer> createFromConfigId;

    /**
     * @return Unique identifier of the existing configuration being cloned to create the new configuration
     * 
     */
    public Output<Optional<Integer>> createFromConfigId() {
        return Codegen.optional(this.createFromConfigId);
    }
    /**
     * Version number of the existing configuration being cloned to create the new configuration
     * 
     */
    @Export(name="createFromVersion", refs={Integer.class}, tree="[0]")
    private Output</* @Nullable */ Integer> createFromVersion;

    /**
     * @return Version number of the existing configuration being cloned to create the new configuration
     * 
     */
    public Output<Optional<Integer>> createFromVersion() {
        return Codegen.optional(this.createFromVersion);
    }
    /**
     * Brief description of the new configuration
     * 
     */
    @Export(name="description", refs={String.class}, tree="[0]")
    private Output<String> description;

    /**
     * @return Brief description of the new configuration
     * 
     */
    public Output<String> description() {
        return this.description;
    }
    /**
     * Unique identifier of the contract group associated with the new configuration
     * 
     */
    @Export(name="groupId", refs={Integer.class}, tree="[0]")
    private Output<Integer> groupId;

    /**
     * @return Unique identifier of the contract group associated with the new configuration
     * 
     */
    public Output<Integer> groupId() {
        return this.groupId;
    }
    /**
     * Hostnames to be protected by the new configuration
     * 
     */
    @Export(name="hostNames", refs={List.class,String.class}, tree="[0,1]")
    private Output<List<String>> hostNames;

    /**
     * @return Hostnames to be protected by the new configuration
     * 
     */
    public Output<List<String>> hostNames() {
        return this.hostNames;
    }
    /**
     * Name of the new configuration
     * 
     */
    @Export(name="name", refs={String.class}, tree="[0]")
    private Output<String> name;

    /**
     * @return Name of the new configuration
     * 
     */
    public Output<String> name() {
        return this.name;
    }

    /**
     *
     * @param name The _unique_ name of the resulting resource.
     */
    public AppSecConfiguration(java.lang.String name) {
        this(name, AppSecConfigurationArgs.Empty);
    }
    /**
     *
     * @param name The _unique_ name of the resulting resource.
     * @param args The arguments to use to populate this resource's properties.
     */
    public AppSecConfiguration(java.lang.String name, AppSecConfigurationArgs args) {
        this(name, args, null);
    }
    /**
     *
     * @param name The _unique_ name of the resulting resource.
     * @param args The arguments to use to populate this resource's properties.
     * @param options A bag of options that control this resource's behavior.
     */
    public AppSecConfiguration(java.lang.String name, AppSecConfigurationArgs args, @Nullable com.pulumi.resources.CustomResourceOptions options) {
        super("akamai:index/appSecConfiguration:AppSecConfiguration", name, makeArgs(args, options), makeResourceOptions(options, Codegen.empty()), false);
    }

    private AppSecConfiguration(java.lang.String name, Output<java.lang.String> id, @Nullable AppSecConfigurationState state, @Nullable com.pulumi.resources.CustomResourceOptions options) {
        super("akamai:index/appSecConfiguration:AppSecConfiguration", name, state, makeResourceOptions(options, id), false);
    }

    private static AppSecConfigurationArgs makeArgs(AppSecConfigurationArgs args, @Nullable com.pulumi.resources.CustomResourceOptions options) {
        if (options != null && options.getUrn().isPresent()) {
            return null;
        }
        return args == null ? AppSecConfigurationArgs.Empty : args;
    }

    private static com.pulumi.resources.CustomResourceOptions makeResourceOptions(@Nullable com.pulumi.resources.CustomResourceOptions options, @Nullable Output<java.lang.String> id) {
        var defaultOptions = com.pulumi.resources.CustomResourceOptions.builder()
            .version(Utilities.getVersion())
            .build();
        return com.pulumi.resources.CustomResourceOptions.merge(defaultOptions, options, id);
    }

    /**
     * Get an existing Host resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state
     * @param options Optional settings to control the behavior of the CustomResource.
     */
    public static AppSecConfiguration get(java.lang.String name, Output<java.lang.String> id, @Nullable AppSecConfigurationState state, @Nullable com.pulumi.resources.CustomResourceOptions options) {
        return new AppSecConfiguration(name, id, state, options);
    }
}
