// *** WARNING: this file was generated by test. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***

package com.pulumi.akamai;

import com.pulumi.core.Output;
import com.pulumi.core.annotations.Import;
import com.pulumi.exceptions.MissingRequiredPropertyException;
import java.lang.Boolean;
import java.lang.Integer;
import java.lang.String;
import java.util.Objects;


public final class AppSecPenaltyBoxArgs extends com.pulumi.resources.ResourceArgs {

    public static final AppSecPenaltyBoxArgs Empty = new AppSecPenaltyBoxArgs();

    /**
     * Unique identifier of the security configuration
     * 
     */
    @Import(name="configId", required=true)
    private Output<Integer> configId;

    /**
     * @return Unique identifier of the security configuration
     * 
     */
    public Output<Integer> configId() {
        return this.configId;
    }

    /**
     * The action to be taken when the penalty box is triggered
     * 
     */
    @Import(name="penaltyBoxAction", required=true)
    private Output<String> penaltyBoxAction;

    /**
     * @return The action to be taken when the penalty box is triggered
     * 
     */
    public Output<String> penaltyBoxAction() {
        return this.penaltyBoxAction;
    }

    /**
     * Whether to enable the penalty box for the specified security policy
     * 
     */
    @Import(name="penaltyBoxProtection", required=true)
    private Output<Boolean> penaltyBoxProtection;

    /**
     * @return Whether to enable the penalty box for the specified security policy
     * 
     */
    public Output<Boolean> penaltyBoxProtection() {
        return this.penaltyBoxProtection;
    }

    /**
     * Unique identifier of the security policy
     * 
     */
    @Import(name="securityPolicyId", required=true)
    private Output<String> securityPolicyId;

    /**
     * @return Unique identifier of the security policy
     * 
     */
    public Output<String> securityPolicyId() {
        return this.securityPolicyId;
    }

    private AppSecPenaltyBoxArgs() {}

    private AppSecPenaltyBoxArgs(AppSecPenaltyBoxArgs $) {
        this.configId = $.configId;
        this.penaltyBoxAction = $.penaltyBoxAction;
        this.penaltyBoxProtection = $.penaltyBoxProtection;
        this.securityPolicyId = $.securityPolicyId;
    }

    public static Builder builder() {
        return new Builder();
    }
    public static Builder builder(AppSecPenaltyBoxArgs defaults) {
        return new Builder(defaults);
    }

    public static final class Builder {
        private AppSecPenaltyBoxArgs $;

        public Builder() {
            $ = new AppSecPenaltyBoxArgs();
        }

        public Builder(AppSecPenaltyBoxArgs defaults) {
            $ = new AppSecPenaltyBoxArgs(Objects.requireNonNull(defaults));
        }

        /**
         * @param configId Unique identifier of the security configuration
         * 
         * @return builder
         * 
         */
        public Builder configId(Output<Integer> configId) {
            $.configId = configId;
            return this;
        }

        /**
         * @param configId Unique identifier of the security configuration
         * 
         * @return builder
         * 
         */
        public Builder configId(Integer configId) {
            return configId(Output.of(configId));
        }

        /**
         * @param penaltyBoxAction The action to be taken when the penalty box is triggered
         * 
         * @return builder
         * 
         */
        public Builder penaltyBoxAction(Output<String> penaltyBoxAction) {
            $.penaltyBoxAction = penaltyBoxAction;
            return this;
        }

        /**
         * @param penaltyBoxAction The action to be taken when the penalty box is triggered
         * 
         * @return builder
         * 
         */
        public Builder penaltyBoxAction(String penaltyBoxAction) {
            return penaltyBoxAction(Output.of(penaltyBoxAction));
        }

        /**
         * @param penaltyBoxProtection Whether to enable the penalty box for the specified security policy
         * 
         * @return builder
         * 
         */
        public Builder penaltyBoxProtection(Output<Boolean> penaltyBoxProtection) {
            $.penaltyBoxProtection = penaltyBoxProtection;
            return this;
        }

        /**
         * @param penaltyBoxProtection Whether to enable the penalty box for the specified security policy
         * 
         * @return builder
         * 
         */
        public Builder penaltyBoxProtection(Boolean penaltyBoxProtection) {
            return penaltyBoxProtection(Output.of(penaltyBoxProtection));
        }

        /**
         * @param securityPolicyId Unique identifier of the security policy
         * 
         * @return builder
         * 
         */
        public Builder securityPolicyId(Output<String> securityPolicyId) {
            $.securityPolicyId = securityPolicyId;
            return this;
        }

        /**
         * @param securityPolicyId Unique identifier of the security policy
         * 
         * @return builder
         * 
         */
        public Builder securityPolicyId(String securityPolicyId) {
            return securityPolicyId(Output.of(securityPolicyId));
        }

        public AppSecPenaltyBoxArgs build() {
            if ($.configId == null) {
                throw new MissingRequiredPropertyException("AppSecPenaltyBoxArgs", "configId");
            }
            if ($.penaltyBoxAction == null) {
                throw new MissingRequiredPropertyException("AppSecPenaltyBoxArgs", "penaltyBoxAction");
            }
            if ($.penaltyBoxProtection == null) {
                throw new MissingRequiredPropertyException("AppSecPenaltyBoxArgs", "penaltyBoxProtection");
            }
            if ($.securityPolicyId == null) {
                throw new MissingRequiredPropertyException("AppSecPenaltyBoxArgs", "securityPolicyId");
            }
            return $;
        }
    }

}
