// *** WARNING: this file was generated by test. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***

package com.pulumi.akamai;

import com.pulumi.core.Output;
import com.pulumi.core.annotations.Import;
import com.pulumi.exceptions.MissingRequiredPropertyException;
import java.lang.Integer;
import java.lang.String;
import java.util.Objects;


public final class AppSecRatePolicyActionArgs extends com.pulumi.resources.ResourceArgs {

    public static final AppSecRatePolicyActionArgs Empty = new AppSecRatePolicyActionArgs();

    /**
     * Unique identifier of the security configuration
     * 
     */
    @Import(name="configId", required=true)
    private Output<Integer> configId;

    /**
     * @return Unique identifier of the security configuration
     * 
     */
    public Output<Integer> configId() {
        return this.configId;
    }

    /**
     * Action to be taken for requests coming from an IPv4 address
     * 
     */
    @Import(name="ipv4Action", required=true)
    private Output<String> ipv4Action;

    /**
     * @return Action to be taken for requests coming from an IPv4 address
     * 
     */
    public Output<String> ipv4Action() {
        return this.ipv4Action;
    }

    /**
     * Action to be taken for requests coming from an IPv6 address
     * 
     */
    @Import(name="ipv6Action", required=true)
    private Output<String> ipv6Action;

    /**
     * @return Action to be taken for requests coming from an IPv6 address
     * 
     */
    public Output<String> ipv6Action() {
        return this.ipv6Action;
    }

    /**
     * Unique identifier of the rate policy
     * 
     */
    @Import(name="ratePolicyId", required=true)
    private Output<Integer> ratePolicyId;

    /**
     * @return Unique identifier of the rate policy
     * 
     */
    public Output<Integer> ratePolicyId() {
        return this.ratePolicyId;
    }

    /**
     * Unique identifier of the security policy
     * 
     */
    @Import(name="securityPolicyId", required=true)
    private Output<String> securityPolicyId;

    /**
     * @return Unique identifier of the security policy
     * 
     */
    public Output<String> securityPolicyId() {
        return this.securityPolicyId;
    }

    private AppSecRatePolicyActionArgs() {}

    private AppSecRatePolicyActionArgs(AppSecRatePolicyActionArgs $) {
        this.configId = $.configId;
        this.ipv4Action = $.ipv4Action;
        this.ipv6Action = $.ipv6Action;
        this.ratePolicyId = $.ratePolicyId;
        this.securityPolicyId = $.securityPolicyId;
    }

    public static Builder builder() {
        return new Builder();
    }
    public static Builder builder(AppSecRatePolicyActionArgs defaults) {
        return new Builder(defaults);
    }

    public static final class Builder {
        private AppSecRatePolicyActionArgs $;

        public Builder() {
            $ = new AppSecRatePolicyActionArgs();
        }

        public Builder(AppSecRatePolicyActionArgs defaults) {
            $ = new AppSecRatePolicyActionArgs(Objects.requireNonNull(defaults));
        }

        /**
         * @param configId Unique identifier of the security configuration
         * 
         * @return builder
         * 
         */
        public Builder configId(Output<Integer> configId) {
            $.configId = configId;
            return this;
        }

        /**
         * @param configId Unique identifier of the security configuration
         * 
         * @return builder
         * 
         */
        public Builder configId(Integer configId) {
            return configId(Output.of(configId));
        }

        /**
         * @param ipv4Action Action to be taken for requests coming from an IPv4 address
         * 
         * @return builder
         * 
         */
        public Builder ipv4Action(Output<String> ipv4Action) {
            $.ipv4Action = ipv4Action;
            return this;
        }

        /**
         * @param ipv4Action Action to be taken for requests coming from an IPv4 address
         * 
         * @return builder
         * 
         */
        public Builder ipv4Action(String ipv4Action) {
            return ipv4Action(Output.of(ipv4Action));
        }

        /**
         * @param ipv6Action Action to be taken for requests coming from an IPv6 address
         * 
         * @return builder
         * 
         */
        public Builder ipv6Action(Output<String> ipv6Action) {
            $.ipv6Action = ipv6Action;
            return this;
        }

        /**
         * @param ipv6Action Action to be taken for requests coming from an IPv6 address
         * 
         * @return builder
         * 
         */
        public Builder ipv6Action(String ipv6Action) {
            return ipv6Action(Output.of(ipv6Action));
        }

        /**
         * @param ratePolicyId Unique identifier of the rate policy
         * 
         * @return builder
         * 
         */
        public Builder ratePolicyId(Output<Integer> ratePolicyId) {
            $.ratePolicyId = ratePolicyId;
            return this;
        }

        /**
         * @param ratePolicyId Unique identifier of the rate policy
         * 
         * @return builder
         * 
         */
        public Builder ratePolicyId(Integer ratePolicyId) {
            return ratePolicyId(Output.of(ratePolicyId));
        }

        /**
         * @param securityPolicyId Unique identifier of the security policy
         * 
         * @return builder
         * 
         */
        public Builder securityPolicyId(Output<String> securityPolicyId) {
            $.securityPolicyId = securityPolicyId;
            return this;
        }

        /**
         * @param securityPolicyId Unique identifier of the security policy
         * 
         * @return builder
         * 
         */
        public Builder securityPolicyId(String securityPolicyId) {
            return securityPolicyId(Output.of(securityPolicyId));
        }

        public AppSecRatePolicyActionArgs build() {
            if ($.configId == null) {
                throw new MissingRequiredPropertyException("AppSecRatePolicyActionArgs", "configId");
            }
            if ($.ipv4Action == null) {
                throw new MissingRequiredPropertyException("AppSecRatePolicyActionArgs", "ipv4Action");
            }
            if ($.ipv6Action == null) {
                throw new MissingRequiredPropertyException("AppSecRatePolicyActionArgs", "ipv6Action");
            }
            if ($.ratePolicyId == null) {
                throw new MissingRequiredPropertyException("AppSecRatePolicyActionArgs", "ratePolicyId");
            }
            if ($.securityPolicyId == null) {
                throw new MissingRequiredPropertyException("AppSecRatePolicyActionArgs", "securityPolicyId");
            }
            return $;
        }
    }

}
