// *** WARNING: this file was generated by test. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***

package com.pulumi.akamai;

import com.pulumi.core.Output;
import com.pulumi.core.annotations.Import;
import com.pulumi.exceptions.MissingRequiredPropertyException;
import java.lang.Boolean;
import java.lang.Integer;
import java.lang.String;
import java.util.Objects;


public final class AppSecReputationProfileAnalysisArgs extends com.pulumi.resources.ResourceArgs {

    public static final AppSecReputationProfileAnalysisArgs Empty = new AppSecReputationProfileAnalysisArgs();

    /**
     * Unique identifier of the security configuration
     * 
     */
    @Import(name="configId", required=true)
    private Output<Integer> configId;

    /**
     * @return Unique identifier of the security configuration
     * 
     */
    public Output<Integer> configId() {
        return this.configId;
    }

    /**
     * Whether to add a value indicating that shared IPs are included in HTTP header and SIEM integration
     * 
     */
    @Import(name="forwardSharedIpToHttpHeaderSiem", required=true)
    private Output<Boolean> forwardSharedIpToHttpHeaderSiem;

    /**
     * @return Whether to add a value indicating that shared IPs are included in HTTP header and SIEM integration
     * 
     */
    public Output<Boolean> forwardSharedIpToHttpHeaderSiem() {
        return this.forwardSharedIpToHttpHeaderSiem;
    }

    /**
     * Whether to add client reputation details to requests forwarded to the origin server
     * 
     */
    @Import(name="forwardToHttpHeader", required=true)
    private Output<Boolean> forwardToHttpHeader;

    /**
     * @return Whether to add client reputation details to requests forwarded to the origin server
     * 
     */
    public Output<Boolean> forwardToHttpHeader() {
        return this.forwardToHttpHeader;
    }

    /**
     * Unique identifier of the security policy
     * 
     */
    @Import(name="securityPolicyId", required=true)
    private Output<String> securityPolicyId;

    /**
     * @return Unique identifier of the security policy
     * 
     */
    public Output<String> securityPolicyId() {
        return this.securityPolicyId;
    }

    private AppSecReputationProfileAnalysisArgs() {}

    private AppSecReputationProfileAnalysisArgs(AppSecReputationProfileAnalysisArgs $) {
        this.configId = $.configId;
        this.forwardSharedIpToHttpHeaderSiem = $.forwardSharedIpToHttpHeaderSiem;
        this.forwardToHttpHeader = $.forwardToHttpHeader;
        this.securityPolicyId = $.securityPolicyId;
    }

    public static Builder builder() {
        return new Builder();
    }
    public static Builder builder(AppSecReputationProfileAnalysisArgs defaults) {
        return new Builder(defaults);
    }

    public static final class Builder {
        private AppSecReputationProfileAnalysisArgs $;

        public Builder() {
            $ = new AppSecReputationProfileAnalysisArgs();
        }

        public Builder(AppSecReputationProfileAnalysisArgs defaults) {
            $ = new AppSecReputationProfileAnalysisArgs(Objects.requireNonNull(defaults));
        }

        /**
         * @param configId Unique identifier of the security configuration
         * 
         * @return builder
         * 
         */
        public Builder configId(Output<Integer> configId) {
            $.configId = configId;
            return this;
        }

        /**
         * @param configId Unique identifier of the security configuration
         * 
         * @return builder
         * 
         */
        public Builder configId(Integer configId) {
            return configId(Output.of(configId));
        }

        /**
         * @param forwardSharedIpToHttpHeaderSiem Whether to add a value indicating that shared IPs are included in HTTP header and SIEM integration
         * 
         * @return builder
         * 
         */
        public Builder forwardSharedIpToHttpHeaderSiem(Output<Boolean> forwardSharedIpToHttpHeaderSiem) {
            $.forwardSharedIpToHttpHeaderSiem = forwardSharedIpToHttpHeaderSiem;
            return this;
        }

        /**
         * @param forwardSharedIpToHttpHeaderSiem Whether to add a value indicating that shared IPs are included in HTTP header and SIEM integration
         * 
         * @return builder
         * 
         */
        public Builder forwardSharedIpToHttpHeaderSiem(Boolean forwardSharedIpToHttpHeaderSiem) {
            return forwardSharedIpToHttpHeaderSiem(Output.of(forwardSharedIpToHttpHeaderSiem));
        }

        /**
         * @param forwardToHttpHeader Whether to add client reputation details to requests forwarded to the origin server
         * 
         * @return builder
         * 
         */
        public Builder forwardToHttpHeader(Output<Boolean> forwardToHttpHeader) {
            $.forwardToHttpHeader = forwardToHttpHeader;
            return this;
        }

        /**
         * @param forwardToHttpHeader Whether to add client reputation details to requests forwarded to the origin server
         * 
         * @return builder
         * 
         */
        public Builder forwardToHttpHeader(Boolean forwardToHttpHeader) {
            return forwardToHttpHeader(Output.of(forwardToHttpHeader));
        }

        /**
         * @param securityPolicyId Unique identifier of the security policy
         * 
         * @return builder
         * 
         */
        public Builder securityPolicyId(Output<String> securityPolicyId) {
            $.securityPolicyId = securityPolicyId;
            return this;
        }

        /**
         * @param securityPolicyId Unique identifier of the security policy
         * 
         * @return builder
         * 
         */
        public Builder securityPolicyId(String securityPolicyId) {
            return securityPolicyId(Output.of(securityPolicyId));
        }

        public AppSecReputationProfileAnalysisArgs build() {
            if ($.configId == null) {
                throw new MissingRequiredPropertyException("AppSecReputationProfileAnalysisArgs", "configId");
            }
            if ($.forwardSharedIpToHttpHeaderSiem == null) {
                throw new MissingRequiredPropertyException("AppSecReputationProfileAnalysisArgs", "forwardSharedIpToHttpHeaderSiem");
            }
            if ($.forwardToHttpHeader == null) {
                throw new MissingRequiredPropertyException("AppSecReputationProfileAnalysisArgs", "forwardToHttpHeader");
            }
            if ($.securityPolicyId == null) {
                throw new MissingRequiredPropertyException("AppSecReputationProfileAnalysisArgs", "securityPolicyId");
            }
            return $;
        }
    }

}
