// *** WARNING: this file was generated by test. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***

package com.pulumi.akamai;

import com.pulumi.akamai.ClientlistListArgs;
import com.pulumi.akamai.Utilities;
import com.pulumi.akamai.inputs.ClientlistListState;
import com.pulumi.akamai.outputs.ClientlistListItem;
import com.pulumi.core.Output;
import com.pulumi.core.annotations.Export;
import com.pulumi.core.annotations.ResourceType;
import com.pulumi.core.internal.Codegen;
import java.lang.Integer;
import java.lang.String;
import java.util.List;
import java.util.Optional;
import javax.annotation.Nullable;

@ResourceType(type="akamai:index/clientlistList:ClientlistList")
public class ClientlistList extends com.pulumi.resources.CustomResource {
    /**
     * Contract ID for which client list is assigned.
     * 
     */
    @Export(name="contractId", refs={String.class}, tree="[0]")
    private Output<String> contractId;

    /**
     * @return Contract ID for which client list is assigned.
     * 
     */
    public Output<String> contractId() {
        return this.contractId;
    }
    /**
     * Group ID for which client list is assigned.
     * 
     */
    @Export(name="groupId", refs={Integer.class}, tree="[0]")
    private Output<Integer> groupId;

    /**
     * @return Group ID for which client list is assigned.
     * 
     */
    public Output<Integer> groupId() {
        return this.groupId;
    }
    /**
     * Set of items containing item information.
     * 
     */
    @Export(name="items", refs={List.class,ClientlistListItem.class}, tree="[0,1]")
    private Output</* @Nullable */ List<ClientlistListItem>> items;

    /**
     * @return Set of items containing item information.
     * 
     */
    public Output<Optional<List<ClientlistListItem>>> items() {
        return Codegen.optional(this.items);
    }
    /**
     * The number of items that a client list contains.
     * 
     */
    @Export(name="itemsCount", refs={Integer.class}, tree="[0]")
    private Output<Integer> itemsCount;

    /**
     * @return The number of items that a client list contains.
     * 
     */
    public Output<Integer> itemsCount() {
        return this.itemsCount;
    }
    /**
     * The ID of the client list.
     * 
     */
    @Export(name="listId", refs={String.class}, tree="[0]")
    private Output<String> listId;

    /**
     * @return The ID of the client list.
     * 
     */
    public Output<String> listId() {
        return this.listId;
    }
    /**
     * The name of the client list.
     * 
     */
    @Export(name="name", refs={String.class}, tree="[0]")
    private Output<String> name;

    /**
     * @return The name of the client list.
     * 
     */
    public Output<String> name() {
        return this.name;
    }
    /**
     * The client list notes.
     * 
     */
    @Export(name="notes", refs={String.class}, tree="[0]")
    private Output</* @Nullable */ String> notes;

    /**
     * @return The client list notes.
     * 
     */
    public Output<Optional<String>> notes() {
        return Codegen.optional(this.notes);
    }
    /**
     * The client list tags.
     * 
     */
    @Export(name="tags", refs={List.class,String.class}, tree="[0,1]")
    private Output</* @Nullable */ List<String>> tags;

    /**
     * @return The client list tags.
     * 
     */
    public Output<Optional<List<String>>> tags() {
        return Codegen.optional(this.tags);
    }
    /**
     * The type of the client list. Valid types: [IP GEO ASN TLS_FINGERPRINT FILE_HASH]
     * 
     */
    @Export(name="type", refs={String.class}, tree="[0]")
    private Output<String> type;

    /**
     * @return The type of the client list. Valid types: [IP GEO ASN TLS_FINGERPRINT FILE_HASH]
     * 
     */
    public Output<String> type() {
        return this.type;
    }
    /**
     * The current version of the client list.
     * 
     */
    @Export(name="version", refs={Integer.class}, tree="[0]")
    private Output<Integer> version;

    /**
     * @return The current version of the client list.
     * 
     */
    public Output<Integer> version() {
        return this.version;
    }

    /**
     *
     * @param name The _unique_ name of the resulting resource.
     */
    public ClientlistList(java.lang.String name) {
        this(name, ClientlistListArgs.Empty);
    }
    /**
     *
     * @param name The _unique_ name of the resulting resource.
     * @param args The arguments to use to populate this resource's properties.
     */
    public ClientlistList(java.lang.String name, ClientlistListArgs args) {
        this(name, args, null);
    }
    /**
     *
     * @param name The _unique_ name of the resulting resource.
     * @param args The arguments to use to populate this resource's properties.
     * @param options A bag of options that control this resource's behavior.
     */
    public ClientlistList(java.lang.String name, ClientlistListArgs args, @Nullable com.pulumi.resources.CustomResourceOptions options) {
        super("akamai:index/clientlistList:ClientlistList", name, makeArgs(args, options), makeResourceOptions(options, Codegen.empty()), false);
    }

    private ClientlistList(java.lang.String name, Output<java.lang.String> id, @Nullable ClientlistListState state, @Nullable com.pulumi.resources.CustomResourceOptions options) {
        super("akamai:index/clientlistList:ClientlistList", name, state, makeResourceOptions(options, id), false);
    }

    private static ClientlistListArgs makeArgs(ClientlistListArgs args, @Nullable com.pulumi.resources.CustomResourceOptions options) {
        if (options != null && options.getUrn().isPresent()) {
            return null;
        }
        return args == null ? ClientlistListArgs.Empty : args;
    }

    private static com.pulumi.resources.CustomResourceOptions makeResourceOptions(@Nullable com.pulumi.resources.CustomResourceOptions options, @Nullable Output<java.lang.String> id) {
        var defaultOptions = com.pulumi.resources.CustomResourceOptions.builder()
            .version(Utilities.getVersion())
            .build();
        return com.pulumi.resources.CustomResourceOptions.merge(defaultOptions, options, id);
    }

    /**
     * Get an existing Host resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state
     * @param options Optional settings to control the behavior of the CustomResource.
     */
    public static ClientlistList get(java.lang.String name, Output<java.lang.String> id, @Nullable ClientlistListState state, @Nullable com.pulumi.resources.CustomResourceOptions options) {
        return new ClientlistList(name, id, state, options);
    }
}
