// *** WARNING: this file was generated by test. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***

package com.pulumi.akamai;

import com.pulumi.akamai.inputs.ClientlistListItemArgs;
import com.pulumi.core.Output;
import com.pulumi.core.annotations.Import;
import com.pulumi.exceptions.MissingRequiredPropertyException;
import java.lang.Integer;
import java.lang.String;
import java.util.List;
import java.util.Objects;
import java.util.Optional;
import javax.annotation.Nullable;


public final class ClientlistListArgs extends com.pulumi.resources.ResourceArgs {

    public static final ClientlistListArgs Empty = new ClientlistListArgs();

    /**
     * Contract ID for which client list is assigned.
     * 
     */
    @Import(name="contractId", required=true)
    private Output<String> contractId;

    /**
     * @return Contract ID for which client list is assigned.
     * 
     */
    public Output<String> contractId() {
        return this.contractId;
    }

    /**
     * Group ID for which client list is assigned.
     * 
     */
    @Import(name="groupId", required=true)
    private Output<Integer> groupId;

    /**
     * @return Group ID for which client list is assigned.
     * 
     */
    public Output<Integer> groupId() {
        return this.groupId;
    }

    /**
     * Set of items containing item information.
     * 
     */
    @Import(name="items")
    private @Nullable Output<List<ClientlistListItemArgs>> items;

    /**
     * @return Set of items containing item information.
     * 
     */
    public Optional<Output<List<ClientlistListItemArgs>>> items() {
        return Optional.ofNullable(this.items);
    }

    /**
     * The name of the client list.
     * 
     */
    @Import(name="name")
    private @Nullable Output<String> name;

    /**
     * @return The name of the client list.
     * 
     */
    public Optional<Output<String>> name() {
        return Optional.ofNullable(this.name);
    }

    /**
     * The client list notes.
     * 
     */
    @Import(name="notes")
    private @Nullable Output<String> notes;

    /**
     * @return The client list notes.
     * 
     */
    public Optional<Output<String>> notes() {
        return Optional.ofNullable(this.notes);
    }

    /**
     * The client list tags.
     * 
     */
    @Import(name="tags")
    private @Nullable Output<List<String>> tags;

    /**
     * @return The client list tags.
     * 
     */
    public Optional<Output<List<String>>> tags() {
        return Optional.ofNullable(this.tags);
    }

    /**
     * The type of the client list. Valid types: [IP GEO ASN TLS_FINGERPRINT FILE_HASH]
     * 
     */
    @Import(name="type", required=true)
    private Output<String> type;

    /**
     * @return The type of the client list. Valid types: [IP GEO ASN TLS_FINGERPRINT FILE_HASH]
     * 
     */
    public Output<String> type() {
        return this.type;
    }

    private ClientlistListArgs() {}

    private ClientlistListArgs(ClientlistListArgs $) {
        this.contractId = $.contractId;
        this.groupId = $.groupId;
        this.items = $.items;
        this.name = $.name;
        this.notes = $.notes;
        this.tags = $.tags;
        this.type = $.type;
    }

    public static Builder builder() {
        return new Builder();
    }
    public static Builder builder(ClientlistListArgs defaults) {
        return new Builder(defaults);
    }

    public static final class Builder {
        private ClientlistListArgs $;

        public Builder() {
            $ = new ClientlistListArgs();
        }

        public Builder(ClientlistListArgs defaults) {
            $ = new ClientlistListArgs(Objects.requireNonNull(defaults));
        }

        /**
         * @param contractId Contract ID for which client list is assigned.
         * 
         * @return builder
         * 
         */
        public Builder contractId(Output<String> contractId) {
            $.contractId = contractId;
            return this;
        }

        /**
         * @param contractId Contract ID for which client list is assigned.
         * 
         * @return builder
         * 
         */
        public Builder contractId(String contractId) {
            return contractId(Output.of(contractId));
        }

        /**
         * @param groupId Group ID for which client list is assigned.
         * 
         * @return builder
         * 
         */
        public Builder groupId(Output<Integer> groupId) {
            $.groupId = groupId;
            return this;
        }

        /**
         * @param groupId Group ID for which client list is assigned.
         * 
         * @return builder
         * 
         */
        public Builder groupId(Integer groupId) {
            return groupId(Output.of(groupId));
        }

        /**
         * @param items Set of items containing item information.
         * 
         * @return builder
         * 
         */
        public Builder items(@Nullable Output<List<ClientlistListItemArgs>> items) {
            $.items = items;
            return this;
        }

        /**
         * @param items Set of items containing item information.
         * 
         * @return builder
         * 
         */
        public Builder items(List<ClientlistListItemArgs> items) {
            return items(Output.of(items));
        }

        /**
         * @param items Set of items containing item information.
         * 
         * @return builder
         * 
         */
        public Builder items(ClientlistListItemArgs... items) {
            return items(List.of(items));
        }

        /**
         * @param name The name of the client list.
         * 
         * @return builder
         * 
         */
        public Builder name(@Nullable Output<String> name) {
            $.name = name;
            return this;
        }

        /**
         * @param name The name of the client list.
         * 
         * @return builder
         * 
         */
        public Builder name(String name) {
            return name(Output.of(name));
        }

        /**
         * @param notes The client list notes.
         * 
         * @return builder
         * 
         */
        public Builder notes(@Nullable Output<String> notes) {
            $.notes = notes;
            return this;
        }

        /**
         * @param notes The client list notes.
         * 
         * @return builder
         * 
         */
        public Builder notes(String notes) {
            return notes(Output.of(notes));
        }

        /**
         * @param tags The client list tags.
         * 
         * @return builder
         * 
         */
        public Builder tags(@Nullable Output<List<String>> tags) {
            $.tags = tags;
            return this;
        }

        /**
         * @param tags The client list tags.
         * 
         * @return builder
         * 
         */
        public Builder tags(List<String> tags) {
            return tags(Output.of(tags));
        }

        /**
         * @param tags The client list tags.
         * 
         * @return builder
         * 
         */
        public Builder tags(String... tags) {
            return tags(List.of(tags));
        }

        /**
         * @param type The type of the client list. Valid types: [IP GEO ASN TLS_FINGERPRINT FILE_HASH]
         * 
         * @return builder
         * 
         */
        public Builder type(Output<String> type) {
            $.type = type;
            return this;
        }

        /**
         * @param type The type of the client list. Valid types: [IP GEO ASN TLS_FINGERPRINT FILE_HASH]
         * 
         * @return builder
         * 
         */
        public Builder type(String type) {
            return type(Output.of(type));
        }

        public ClientlistListArgs build() {
            if ($.contractId == null) {
                throw new MissingRequiredPropertyException("ClientlistListArgs", "contractId");
            }
            if ($.groupId == null) {
                throw new MissingRequiredPropertyException("ClientlistListArgs", "groupId");
            }
            if ($.type == null) {
                throw new MissingRequiredPropertyException("ClientlistListArgs", "type");
            }
            return $;
        }
    }

}
