// *** WARNING: this file was generated by test. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***

package com.pulumi.akamai;

import com.pulumi.akamai.CloudletsApplicationLoadBalancerArgs;
import com.pulumi.akamai.Utilities;
import com.pulumi.akamai.inputs.CloudletsApplicationLoadBalancerState;
import com.pulumi.akamai.outputs.CloudletsApplicationLoadBalancerDataCenter;
import com.pulumi.akamai.outputs.CloudletsApplicationLoadBalancerLivenessSettings;
import com.pulumi.core.Output;
import com.pulumi.core.annotations.Export;
import com.pulumi.core.annotations.ResourceType;
import com.pulumi.core.internal.Codegen;
import java.lang.Integer;
import java.lang.String;
import java.util.List;
import java.util.Optional;
import javax.annotation.Nullable;

@ResourceType(type="akamai:index/cloudletsApplicationLoadBalancer:CloudletsApplicationLoadBalancer")
public class CloudletsApplicationLoadBalancer extends com.pulumi.resources.CustomResource {
    /**
     * The type of load balancing being performed. Options include WEIGHTED and PERFORMANCE
     * 
     */
    @Export(name="balancingType", refs={String.class}, tree="[0]")
    private Output</* @Nullable */ String> balancingType;

    /**
     * @return The type of load balancing being performed. Options include WEIGHTED and PERFORMANCE
     * 
     */
    public Output<Optional<String>> balancingType() {
        return Codegen.optional(this.balancingType);
    }
    /**
     * The object containing information on conditional origins being used as data centers for an Application Load Balancer
     * implementation. Only Conditional Origins with an originType of CUSTOMER or NETSTORAGE can be used as data centers in an
     * application load balancer configuration.
     * 
     */
    @Export(name="dataCenters", refs={List.class,CloudletsApplicationLoadBalancerDataCenter.class}, tree="[0,1]")
    private Output<List<CloudletsApplicationLoadBalancerDataCenter>> dataCenters;

    /**
     * @return The object containing information on conditional origins being used as data centers for an Application Load Balancer
     * implementation. Only Conditional Origins with an originType of CUSTOMER or NETSTORAGE can be used as data centers in an
     * application load balancer configuration.
     * 
     */
    public Output<List<CloudletsApplicationLoadBalancerDataCenter>> dataCenters() {
        return this.dataCenters;
    }
    /**
     * The load balancer configuration description
     * 
     */
    @Export(name="description", refs={String.class}, tree="[0]")
    private Output</* @Nullable */ String> description;

    /**
     * @return The load balancer configuration description
     * 
     */
    public Output<Optional<String>> description() {
        return Codegen.optional(this.description);
    }
    @Export(name="livenessSettings", refs={CloudletsApplicationLoadBalancerLivenessSettings.class}, tree="[0]")
    private Output</* @Nullable */ CloudletsApplicationLoadBalancerLivenessSettings> livenessSettings;

    public Output<Optional<CloudletsApplicationLoadBalancerLivenessSettings>> livenessSettings() {
        return Codegen.optional(this.livenessSettings);
    }
    /**
     * The conditional origin’s unique identifier
     * 
     */
    @Export(name="originId", refs={String.class}, tree="[0]")
    private Output<String> originId;

    /**
     * @return The conditional origin’s unique identifier
     * 
     */
    public Output<String> originId() {
        return this.originId;
    }
    /**
     * The load balancer configuration version
     * 
     */
    @Export(name="version", refs={Integer.class}, tree="[0]")
    private Output<Integer> version;

    /**
     * @return The load balancer configuration version
     * 
     */
    public Output<Integer> version() {
        return this.version;
    }
    /**
     * Describes warnings during activation of load balancer configuration
     * 
     */
    @Export(name="warnings", refs={String.class}, tree="[0]")
    private Output<String> warnings;

    /**
     * @return Describes warnings during activation of load balancer configuration
     * 
     */
    public Output<String> warnings() {
        return this.warnings;
    }

    /**
     *
     * @param name The _unique_ name of the resulting resource.
     */
    public CloudletsApplicationLoadBalancer(java.lang.String name) {
        this(name, CloudletsApplicationLoadBalancerArgs.Empty);
    }
    /**
     *
     * @param name The _unique_ name of the resulting resource.
     * @param args The arguments to use to populate this resource's properties.
     */
    public CloudletsApplicationLoadBalancer(java.lang.String name, CloudletsApplicationLoadBalancerArgs args) {
        this(name, args, null);
    }
    /**
     *
     * @param name The _unique_ name of the resulting resource.
     * @param args The arguments to use to populate this resource's properties.
     * @param options A bag of options that control this resource's behavior.
     */
    public CloudletsApplicationLoadBalancer(java.lang.String name, CloudletsApplicationLoadBalancerArgs args, @Nullable com.pulumi.resources.CustomResourceOptions options) {
        super("akamai:index/cloudletsApplicationLoadBalancer:CloudletsApplicationLoadBalancer", name, makeArgs(args, options), makeResourceOptions(options, Codegen.empty()), false);
    }

    private CloudletsApplicationLoadBalancer(java.lang.String name, Output<java.lang.String> id, @Nullable CloudletsApplicationLoadBalancerState state, @Nullable com.pulumi.resources.CustomResourceOptions options) {
        super("akamai:index/cloudletsApplicationLoadBalancer:CloudletsApplicationLoadBalancer", name, state, makeResourceOptions(options, id), false);
    }

    private static CloudletsApplicationLoadBalancerArgs makeArgs(CloudletsApplicationLoadBalancerArgs args, @Nullable com.pulumi.resources.CustomResourceOptions options) {
        if (options != null && options.getUrn().isPresent()) {
            return null;
        }
        return args == null ? CloudletsApplicationLoadBalancerArgs.Empty : args;
    }

    private static com.pulumi.resources.CustomResourceOptions makeResourceOptions(@Nullable com.pulumi.resources.CustomResourceOptions options, @Nullable Output<java.lang.String> id) {
        var defaultOptions = com.pulumi.resources.CustomResourceOptions.builder()
            .version(Utilities.getVersion())
            .build();
        return com.pulumi.resources.CustomResourceOptions.merge(defaultOptions, options, id);
    }

    /**
     * Get an existing Host resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state
     * @param options Optional settings to control the behavior of the CustomResource.
     */
    public static CloudletsApplicationLoadBalancer get(java.lang.String name, Output<java.lang.String> id, @Nullable CloudletsApplicationLoadBalancerState state, @Nullable com.pulumi.resources.CustomResourceOptions options) {
        return new CloudletsApplicationLoadBalancer(name, id, state, options);
    }
}
