// *** WARNING: this file was generated by test. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***

package com.pulumi.akamai;

import com.pulumi.core.Output;
import com.pulumi.core.annotations.Import;
import com.pulumi.exceptions.MissingRequiredPropertyException;
import java.lang.String;
import java.util.Objects;
import java.util.Optional;
import javax.annotation.Nullable;


public final class ImagingPolicySetArgs extends com.pulumi.resources.ResourceArgs {

    public static final ImagingPolicySetArgs Empty = new ImagingPolicySetArgs();

    /**
     * The unique identifier for the Akamai Contract containing the Policy Set(s)
     * 
     */
    @Import(name="contractId", required=true)
    private Output<String> contractId;

    /**
     * @return The unique identifier for the Akamai Contract containing the Policy Set(s)
     * 
     */
    public Output<String> contractId() {
        return this.contractId;
    }

    /**
     * A friendly name for the Policy Set
     * 
     */
    @Import(name="name")
    private @Nullable Output<String> name;

    /**
     * @return A friendly name for the Policy Set
     * 
     */
    public Optional<Output<String>> name() {
        return Optional.ofNullable(this.name);
    }

    /**
     * The geographic region which media using this Policy Set is optimized for
     * 
     */
    @Import(name="region", required=true)
    private Output<String> region;

    /**
     * @return The geographic region which media using this Policy Set is optimized for
     * 
     */
    public Output<String> region() {
        return this.region;
    }

    /**
     * The type of media this Policy Set manages
     * 
     */
    @Import(name="type", required=true)
    private Output<String> type;

    /**
     * @return The type of media this Policy Set manages
     * 
     */
    public Output<String> type() {
        return this.type;
    }

    private ImagingPolicySetArgs() {}

    private ImagingPolicySetArgs(ImagingPolicySetArgs $) {
        this.contractId = $.contractId;
        this.name = $.name;
        this.region = $.region;
        this.type = $.type;
    }

    public static Builder builder() {
        return new Builder();
    }
    public static Builder builder(ImagingPolicySetArgs defaults) {
        return new Builder(defaults);
    }

    public static final class Builder {
        private ImagingPolicySetArgs $;

        public Builder() {
            $ = new ImagingPolicySetArgs();
        }

        public Builder(ImagingPolicySetArgs defaults) {
            $ = new ImagingPolicySetArgs(Objects.requireNonNull(defaults));
        }

        /**
         * @param contractId The unique identifier for the Akamai Contract containing the Policy Set(s)
         * 
         * @return builder
         * 
         */
        public Builder contractId(Output<String> contractId) {
            $.contractId = contractId;
            return this;
        }

        /**
         * @param contractId The unique identifier for the Akamai Contract containing the Policy Set(s)
         * 
         * @return builder
         * 
         */
        public Builder contractId(String contractId) {
            return contractId(Output.of(contractId));
        }

        /**
         * @param name A friendly name for the Policy Set
         * 
         * @return builder
         * 
         */
        public Builder name(@Nullable Output<String> name) {
            $.name = name;
            return this;
        }

        /**
         * @param name A friendly name for the Policy Set
         * 
         * @return builder
         * 
         */
        public Builder name(String name) {
            return name(Output.of(name));
        }

        /**
         * @param region The geographic region which media using this Policy Set is optimized for
         * 
         * @return builder
         * 
         */
        public Builder region(Output<String> region) {
            $.region = region;
            return this;
        }

        /**
         * @param region The geographic region which media using this Policy Set is optimized for
         * 
         * @return builder
         * 
         */
        public Builder region(String region) {
            return region(Output.of(region));
        }

        /**
         * @param type The type of media this Policy Set manages
         * 
         * @return builder
         * 
         */
        public Builder type(Output<String> type) {
            $.type = type;
            return this;
        }

        /**
         * @param type The type of media this Policy Set manages
         * 
         * @return builder
         * 
         */
        public Builder type(String type) {
            return type(Output.of(type));
        }

        public ImagingPolicySetArgs build() {
            if ($.contractId == null) {
                throw new MissingRequiredPropertyException("ImagingPolicySetArgs", "contractId");
            }
            if ($.region == null) {
                throw new MissingRequiredPropertyException("ImagingPolicySetArgs", "region");
            }
            if ($.type == null) {
                throw new MissingRequiredPropertyException("ImagingPolicySetArgs", "type");
            }
            return $;
        }
    }

}
