// *** WARNING: this file was generated by test. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***

package com.pulumi.akamai;

import com.pulumi.core.Output;
import com.pulumi.core.annotations.Import;
import com.pulumi.exceptions.MissingRequiredPropertyException;
import java.lang.Integer;
import java.lang.String;
import java.util.List;
import java.util.Objects;
import java.util.Optional;
import javax.annotation.Nullable;


public final class NetworkListActivationsArgs extends com.pulumi.resources.ResourceArgs {

    public static final NetworkListActivationsArgs Empty = new NetworkListActivationsArgs();

    /**
     * The Akamai network on which the list is activated: STAGING or PRODUCTION
     * 
     */
    @Import(name="network")
    private @Nullable Output<String> network;

    /**
     * @return The Akamai network on which the list is activated: STAGING or PRODUCTION
     * 
     */
    public Optional<Output<String>> network() {
        return Optional.ofNullable(this.network);
    }

    /**
     * Unique identifier of the network list
     * 
     */
    @Import(name="networkListId", required=true)
    private Output<String> networkListId;

    /**
     * @return Unique identifier of the network list
     * 
     */
    public Output<String> networkListId() {
        return this.networkListId;
    }

    /**
     * Descriptive text to accompany the activation
     * 
     */
    @Import(name="notes")
    private @Nullable Output<String> notes;

    /**
     * @return Descriptive text to accompany the activation
     * 
     */
    public Optional<Output<String>> notes() {
        return Optional.ofNullable(this.notes);
    }

    /**
     * List of email addresses of Control Center users who receive an email when activation of this list is complete
     * 
     */
    @Import(name="notificationEmails", required=true)
    private Output<List<String>> notificationEmails;

    /**
     * @return List of email addresses of Control Center users who receive an email when activation of this list is complete
     * 
     */
    public Output<List<String>> notificationEmails() {
        return this.notificationEmails;
    }

    /**
     * Identifies the sync point of the network list to be activated
     * 
     */
    @Import(name="syncPoint", required=true)
    private Output<Integer> syncPoint;

    /**
     * @return Identifies the sync point of the network list to be activated
     * 
     */
    public Output<Integer> syncPoint() {
        return this.syncPoint;
    }

    private NetworkListActivationsArgs() {}

    private NetworkListActivationsArgs(NetworkListActivationsArgs $) {
        this.network = $.network;
        this.networkListId = $.networkListId;
        this.notes = $.notes;
        this.notificationEmails = $.notificationEmails;
        this.syncPoint = $.syncPoint;
    }

    public static Builder builder() {
        return new Builder();
    }
    public static Builder builder(NetworkListActivationsArgs defaults) {
        return new Builder(defaults);
    }

    public static final class Builder {
        private NetworkListActivationsArgs $;

        public Builder() {
            $ = new NetworkListActivationsArgs();
        }

        public Builder(NetworkListActivationsArgs defaults) {
            $ = new NetworkListActivationsArgs(Objects.requireNonNull(defaults));
        }

        /**
         * @param network The Akamai network on which the list is activated: STAGING or PRODUCTION
         * 
         * @return builder
         * 
         */
        public Builder network(@Nullable Output<String> network) {
            $.network = network;
            return this;
        }

        /**
         * @param network The Akamai network on which the list is activated: STAGING or PRODUCTION
         * 
         * @return builder
         * 
         */
        public Builder network(String network) {
            return network(Output.of(network));
        }

        /**
         * @param networkListId Unique identifier of the network list
         * 
         * @return builder
         * 
         */
        public Builder networkListId(Output<String> networkListId) {
            $.networkListId = networkListId;
            return this;
        }

        /**
         * @param networkListId Unique identifier of the network list
         * 
         * @return builder
         * 
         */
        public Builder networkListId(String networkListId) {
            return networkListId(Output.of(networkListId));
        }

        /**
         * @param notes Descriptive text to accompany the activation
         * 
         * @return builder
         * 
         */
        public Builder notes(@Nullable Output<String> notes) {
            $.notes = notes;
            return this;
        }

        /**
         * @param notes Descriptive text to accompany the activation
         * 
         * @return builder
         * 
         */
        public Builder notes(String notes) {
            return notes(Output.of(notes));
        }

        /**
         * @param notificationEmails List of email addresses of Control Center users who receive an email when activation of this list is complete
         * 
         * @return builder
         * 
         */
        public Builder notificationEmails(Output<List<String>> notificationEmails) {
            $.notificationEmails = notificationEmails;
            return this;
        }

        /**
         * @param notificationEmails List of email addresses of Control Center users who receive an email when activation of this list is complete
         * 
         * @return builder
         * 
         */
        public Builder notificationEmails(List<String> notificationEmails) {
            return notificationEmails(Output.of(notificationEmails));
        }

        /**
         * @param notificationEmails List of email addresses of Control Center users who receive an email when activation of this list is complete
         * 
         * @return builder
         * 
         */
        public Builder notificationEmails(String... notificationEmails) {
            return notificationEmails(List.of(notificationEmails));
        }

        /**
         * @param syncPoint Identifies the sync point of the network list to be activated
         * 
         * @return builder
         * 
         */
        public Builder syncPoint(Output<Integer> syncPoint) {
            $.syncPoint = syncPoint;
            return this;
        }

        /**
         * @param syncPoint Identifies the sync point of the network list to be activated
         * 
         * @return builder
         * 
         */
        public Builder syncPoint(Integer syncPoint) {
            return syncPoint(Output.of(syncPoint));
        }

        public NetworkListActivationsArgs build() {
            if ($.networkListId == null) {
                throw new MissingRequiredPropertyException("NetworkListActivationsArgs", "networkListId");
            }
            if ($.notificationEmails == null) {
                throw new MissingRequiredPropertyException("NetworkListActivationsArgs", "notificationEmails");
            }
            if ($.syncPoint == null) {
                throw new MissingRequiredPropertyException("NetworkListActivationsArgs", "syncPoint");
            }
            return $;
        }
    }

}
