// *** WARNING: this file was generated by test. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***

package com.pulumi.akamai;

import com.pulumi.core.Output;
import com.pulumi.core.annotations.Import;
import com.pulumi.exceptions.MissingRequiredPropertyException;
import java.lang.String;
import java.util.Objects;
import java.util.Optional;
import javax.annotation.Nullable;


public final class PropertyIncludeArgs extends com.pulumi.resources.ResourceArgs {

    public static final PropertyIncludeArgs Empty = new PropertyIncludeArgs();

    /**
     * Identifies the contract to which the include is assigned
     * 
     */
    @Import(name="contractId", required=true)
    private Output<String> contractId;

    /**
     * @return Identifies the contract to which the include is assigned
     * 
     */
    public Output<String> contractId() {
        return this.contractId;
    }

    /**
     * Identifies the group to which the include is assigned
     * 
     */
    @Import(name="groupId", required=true)
    private Output<String> groupId;

    /**
     * @return Identifies the group to which the include is assigned
     * 
     */
    public Output<String> groupId() {
        return this.groupId;
    }

    /**
     * A descriptive name for the include
     * 
     */
    @Import(name="name")
    private @Nullable Output<String> name;

    /**
     * @return A descriptive name for the include
     * 
     */
    public Optional<Output<String>> name() {
        return Optional.ofNullable(this.name);
    }

    /**
     * The product assigned to the include
     * 
     */
    @Import(name="productId")
    private @Nullable Output<String> productId;

    /**
     * @return The product assigned to the include
     * 
     */
    public Optional<Output<String>> productId() {
        return Optional.ofNullable(this.productId);
    }

    /**
     * Indicates the versioned set of features and criteria
     * 
     */
    @Import(name="ruleFormat", required=true)
    private Output<String> ruleFormat;

    /**
     * @return Indicates the versioned set of features and criteria
     * 
     */
    public Output<String> ruleFormat() {
        return this.ruleFormat;
    }

    /**
     * Property Rules as JSON
     * 
     */
    @Import(name="rules")
    private @Nullable Output<String> rules;

    /**
     * @return Property Rules as JSON
     * 
     */
    public Optional<Output<String>> rules() {
        return Optional.ofNullable(this.rules);
    }

    /**
     * Specifies the type of the include, either &#39;MICROSERVICES&#39; or &#39;COMMON_SETTINGS&#39;
     * 
     */
    @Import(name="type", required=true)
    private Output<String> type;

    /**
     * @return Specifies the type of the include, either &#39;MICROSERVICES&#39; or &#39;COMMON_SETTINGS&#39;
     * 
     */
    public Output<String> type() {
        return this.type;
    }

    private PropertyIncludeArgs() {}

    private PropertyIncludeArgs(PropertyIncludeArgs $) {
        this.contractId = $.contractId;
        this.groupId = $.groupId;
        this.name = $.name;
        this.productId = $.productId;
        this.ruleFormat = $.ruleFormat;
        this.rules = $.rules;
        this.type = $.type;
    }

    public static Builder builder() {
        return new Builder();
    }
    public static Builder builder(PropertyIncludeArgs defaults) {
        return new Builder(defaults);
    }

    public static final class Builder {
        private PropertyIncludeArgs $;

        public Builder() {
            $ = new PropertyIncludeArgs();
        }

        public Builder(PropertyIncludeArgs defaults) {
            $ = new PropertyIncludeArgs(Objects.requireNonNull(defaults));
        }

        /**
         * @param contractId Identifies the contract to which the include is assigned
         * 
         * @return builder
         * 
         */
        public Builder contractId(Output<String> contractId) {
            $.contractId = contractId;
            return this;
        }

        /**
         * @param contractId Identifies the contract to which the include is assigned
         * 
         * @return builder
         * 
         */
        public Builder contractId(String contractId) {
            return contractId(Output.of(contractId));
        }

        /**
         * @param groupId Identifies the group to which the include is assigned
         * 
         * @return builder
         * 
         */
        public Builder groupId(Output<String> groupId) {
            $.groupId = groupId;
            return this;
        }

        /**
         * @param groupId Identifies the group to which the include is assigned
         * 
         * @return builder
         * 
         */
        public Builder groupId(String groupId) {
            return groupId(Output.of(groupId));
        }

        /**
         * @param name A descriptive name for the include
         * 
         * @return builder
         * 
         */
        public Builder name(@Nullable Output<String> name) {
            $.name = name;
            return this;
        }

        /**
         * @param name A descriptive name for the include
         * 
         * @return builder
         * 
         */
        public Builder name(String name) {
            return name(Output.of(name));
        }

        /**
         * @param productId The product assigned to the include
         * 
         * @return builder
         * 
         */
        public Builder productId(@Nullable Output<String> productId) {
            $.productId = productId;
            return this;
        }

        /**
         * @param productId The product assigned to the include
         * 
         * @return builder
         * 
         */
        public Builder productId(String productId) {
            return productId(Output.of(productId));
        }

        /**
         * @param ruleFormat Indicates the versioned set of features and criteria
         * 
         * @return builder
         * 
         */
        public Builder ruleFormat(Output<String> ruleFormat) {
            $.ruleFormat = ruleFormat;
            return this;
        }

        /**
         * @param ruleFormat Indicates the versioned set of features and criteria
         * 
         * @return builder
         * 
         */
        public Builder ruleFormat(String ruleFormat) {
            return ruleFormat(Output.of(ruleFormat));
        }

        /**
         * @param rules Property Rules as JSON
         * 
         * @return builder
         * 
         */
        public Builder rules(@Nullable Output<String> rules) {
            $.rules = rules;
            return this;
        }

        /**
         * @param rules Property Rules as JSON
         * 
         * @return builder
         * 
         */
        public Builder rules(String rules) {
            return rules(Output.of(rules));
        }

        /**
         * @param type Specifies the type of the include, either &#39;MICROSERVICES&#39; or &#39;COMMON_SETTINGS&#39;
         * 
         * @return builder
         * 
         */
        public Builder type(Output<String> type) {
            $.type = type;
            return this;
        }

        /**
         * @param type Specifies the type of the include, either &#39;MICROSERVICES&#39; or &#39;COMMON_SETTINGS&#39;
         * 
         * @return builder
         * 
         */
        public Builder type(String type) {
            return type(Output.of(type));
        }

        public PropertyIncludeArgs build() {
            if ($.contractId == null) {
                throw new MissingRequiredPropertyException("PropertyIncludeArgs", "contractId");
            }
            if ($.groupId == null) {
                throw new MissingRequiredPropertyException("PropertyIncludeArgs", "groupId");
            }
            if ($.ruleFormat == null) {
                throw new MissingRequiredPropertyException("PropertyIncludeArgs", "ruleFormat");
            }
            if ($.type == null) {
                throw new MissingRequiredPropertyException("PropertyIncludeArgs", "type");
            }
            return $;
        }
    }

}
