// *** WARNING: this file was generated by test. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***

package com.pulumi.akamai.inputs;

import com.pulumi.core.Output;
import com.pulumi.core.annotations.Import;
import java.lang.Integer;
import java.lang.String;
import java.util.Objects;
import java.util.Optional;
import javax.annotation.Nullable;


public final class AppSecWafModeState extends com.pulumi.resources.ResourceArgs {

    public static final AppSecWafModeState Empty = new AppSecWafModeState();

    /**
     * Unique identifier of the security configuration
     * 
     */
    @Import(name="configId")
    private @Nullable Output<Integer> configId;

    /**
     * @return Unique identifier of the security configuration
     * 
     */
    public Optional<Output<Integer>> configId() {
        return Optional.ofNullable(this.configId);
    }

    /**
     * Versioning information for the current Kona Rule Set
     * 
     */
    @Import(name="currentRuleset")
    private @Nullable Output<String> currentRuleset;

    /**
     * @return Versioning information for the current Kona Rule Set
     * 
     */
    public Optional<Output<String>> currentRuleset() {
        return Optional.ofNullable(this.currentRuleset);
    }

    /**
     * Date on which the evaluation period ends, if applicable
     * 
     */
    @Import(name="evalExpirationDate")
    private @Nullable Output<String> evalExpirationDate;

    /**
     * @return Date on which the evaluation period ends, if applicable
     * 
     */
    public Optional<Output<String>> evalExpirationDate() {
        return Optional.ofNullable(this.evalExpirationDate);
    }

    /**
     * Versioning information for the Kona Rule Set being evaluated, if applicable
     * 
     */
    @Import(name="evalRuleset")
    private @Nullable Output<String> evalRuleset;

    /**
     * @return Versioning information for the Kona Rule Set being evaluated, if applicable
     * 
     */
    public Optional<Output<String>> evalRuleset() {
        return Optional.ofNullable(this.evalRuleset);
    }

    /**
     * Whether an evaluation is currently in progress
     * 
     */
    @Import(name="evalStatus")
    private @Nullable Output<String> evalStatus;

    /**
     * @return Whether an evaluation is currently in progress
     * 
     */
    public Optional<Output<String>> evalStatus() {
        return Optional.ofNullable(this.evalStatus);
    }

    /**
     * How Kona Rule Set rules should be upgraded (KRS, AAG, ASE_MANUAL or ASE_AUTO)
     * 
     */
    @Import(name="mode")
    private @Nullable Output<String> mode;

    /**
     * @return How Kona Rule Set rules should be upgraded (KRS, AAG, ASE_MANUAL or ASE_AUTO)
     * 
     */
    public Optional<Output<String>> mode() {
        return Optional.ofNullable(this.mode);
    }

    /**
     * Text representation
     * 
     */
    @Import(name="outputText")
    private @Nullable Output<String> outputText;

    /**
     * @return Text representation
     * 
     */
    public Optional<Output<String>> outputText() {
        return Optional.ofNullable(this.outputText);
    }

    /**
     * Unique identifier of the security policy
     * 
     */
    @Import(name="securityPolicyId")
    private @Nullable Output<String> securityPolicyId;

    /**
     * @return Unique identifier of the security policy
     * 
     */
    public Optional<Output<String>> securityPolicyId() {
        return Optional.ofNullable(this.securityPolicyId);
    }

    private AppSecWafModeState() {}

    private AppSecWafModeState(AppSecWafModeState $) {
        this.configId = $.configId;
        this.currentRuleset = $.currentRuleset;
        this.evalExpirationDate = $.evalExpirationDate;
        this.evalRuleset = $.evalRuleset;
        this.evalStatus = $.evalStatus;
        this.mode = $.mode;
        this.outputText = $.outputText;
        this.securityPolicyId = $.securityPolicyId;
    }

    public static Builder builder() {
        return new Builder();
    }
    public static Builder builder(AppSecWafModeState defaults) {
        return new Builder(defaults);
    }

    public static final class Builder {
        private AppSecWafModeState $;

        public Builder() {
            $ = new AppSecWafModeState();
        }

        public Builder(AppSecWafModeState defaults) {
            $ = new AppSecWafModeState(Objects.requireNonNull(defaults));
        }

        /**
         * @param configId Unique identifier of the security configuration
         * 
         * @return builder
         * 
         */
        public Builder configId(@Nullable Output<Integer> configId) {
            $.configId = configId;
            return this;
        }

        /**
         * @param configId Unique identifier of the security configuration
         * 
         * @return builder
         * 
         */
        public Builder configId(Integer configId) {
            return configId(Output.of(configId));
        }

        /**
         * @param currentRuleset Versioning information for the current Kona Rule Set
         * 
         * @return builder
         * 
         */
        public Builder currentRuleset(@Nullable Output<String> currentRuleset) {
            $.currentRuleset = currentRuleset;
            return this;
        }

        /**
         * @param currentRuleset Versioning information for the current Kona Rule Set
         * 
         * @return builder
         * 
         */
        public Builder currentRuleset(String currentRuleset) {
            return currentRuleset(Output.of(currentRuleset));
        }

        /**
         * @param evalExpirationDate Date on which the evaluation period ends, if applicable
         * 
         * @return builder
         * 
         */
        public Builder evalExpirationDate(@Nullable Output<String> evalExpirationDate) {
            $.evalExpirationDate = evalExpirationDate;
            return this;
        }

        /**
         * @param evalExpirationDate Date on which the evaluation period ends, if applicable
         * 
         * @return builder
         * 
         */
        public Builder evalExpirationDate(String evalExpirationDate) {
            return evalExpirationDate(Output.of(evalExpirationDate));
        }

        /**
         * @param evalRuleset Versioning information for the Kona Rule Set being evaluated, if applicable
         * 
         * @return builder
         * 
         */
        public Builder evalRuleset(@Nullable Output<String> evalRuleset) {
            $.evalRuleset = evalRuleset;
            return this;
        }

        /**
         * @param evalRuleset Versioning information for the Kona Rule Set being evaluated, if applicable
         * 
         * @return builder
         * 
         */
        public Builder evalRuleset(String evalRuleset) {
            return evalRuleset(Output.of(evalRuleset));
        }

        /**
         * @param evalStatus Whether an evaluation is currently in progress
         * 
         * @return builder
         * 
         */
        public Builder evalStatus(@Nullable Output<String> evalStatus) {
            $.evalStatus = evalStatus;
            return this;
        }

        /**
         * @param evalStatus Whether an evaluation is currently in progress
         * 
         * @return builder
         * 
         */
        public Builder evalStatus(String evalStatus) {
            return evalStatus(Output.of(evalStatus));
        }

        /**
         * @param mode How Kona Rule Set rules should be upgraded (KRS, AAG, ASE_MANUAL or ASE_AUTO)
         * 
         * @return builder
         * 
         */
        public Builder mode(@Nullable Output<String> mode) {
            $.mode = mode;
            return this;
        }

        /**
         * @param mode How Kona Rule Set rules should be upgraded (KRS, AAG, ASE_MANUAL or ASE_AUTO)
         * 
         * @return builder
         * 
         */
        public Builder mode(String mode) {
            return mode(Output.of(mode));
        }

        /**
         * @param outputText Text representation
         * 
         * @return builder
         * 
         */
        public Builder outputText(@Nullable Output<String> outputText) {
            $.outputText = outputText;
            return this;
        }

        /**
         * @param outputText Text representation
         * 
         * @return builder
         * 
         */
        public Builder outputText(String outputText) {
            return outputText(Output.of(outputText));
        }

        /**
         * @param securityPolicyId Unique identifier of the security policy
         * 
         * @return builder
         * 
         */
        public Builder securityPolicyId(@Nullable Output<String> securityPolicyId) {
            $.securityPolicyId = securityPolicyId;
            return this;
        }

        /**
         * @param securityPolicyId Unique identifier of the security policy
         * 
         * @return builder
         * 
         */
        public Builder securityPolicyId(String securityPolicyId) {
            return securityPolicyId(Output.of(securityPolicyId));
        }

        public AppSecWafModeState build() {
            return $;
        }
    }

}
