// *** WARNING: this file was generated by test. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***

package com.pulumi.akamai.inputs;

import com.pulumi.core.Output;
import com.pulumi.core.annotations.Import;
import java.lang.Integer;
import java.lang.String;
import java.util.Objects;
import java.util.Optional;
import javax.annotation.Nullable;


public final class CloudletsPolicyState extends com.pulumi.resources.ResourceArgs {

    public static final CloudletsPolicyState Empty = new CloudletsPolicyState();

    /**
     * Code for the type of Cloudlet (ALB, AP, AS, CD, ER, FR, IG, or VP)
     * 
     */
    @Import(name="cloudletCode")
    private @Nullable Output<String> cloudletCode;

    /**
     * @return Code for the type of Cloudlet (ALB, AP, AS, CD, ER, FR, IG, or VP)
     * 
     */
    public Optional<Output<String>> cloudletCode() {
        return Optional.ofNullable(this.cloudletCode);
    }

    /**
     * An integer that corresponds to a Cloudlets policy type (0 or 9)
     * 
     */
    @Import(name="cloudletId")
    private @Nullable Output<Integer> cloudletId;

    /**
     * @return An integer that corresponds to a Cloudlets policy type (0 or 9)
     * 
     */
    public Optional<Output<Integer>> cloudletId() {
        return Optional.ofNullable(this.cloudletId);
    }

    /**
     * The description of this specific policy
     * 
     */
    @Import(name="description")
    private @Nullable Output<String> description;

    /**
     * @return The description of this specific policy
     * 
     */
    public Optional<Output<String>> description() {
        return Optional.ofNullable(this.description);
    }

    /**
     * Defines the group association for the policy. You must have edit privileges for the group
     * 
     */
    @Import(name="groupId")
    private @Nullable Output<String> groupId;

    /**
     * @return Defines the group association for the policy. You must have edit privileges for the group
     * 
     */
    public Optional<Output<String>> groupId() {
        return Optional.ofNullable(this.groupId);
    }

    /**
     * The version of the Cloudlet specific matchRules
     * 
     */
    @Import(name="matchRuleFormat")
    private @Nullable Output<String> matchRuleFormat;

    /**
     * @return The version of the Cloudlet specific matchRules
     * 
     */
    public Optional<Output<String>> matchRuleFormat() {
        return Optional.ofNullable(this.matchRuleFormat);
    }

    /**
     * A JSON structure that defines the rules for this policy
     * 
     */
    @Import(name="matchRules")
    private @Nullable Output<String> matchRules;

    /**
     * @return A JSON structure that defines the rules for this policy
     * 
     */
    public Optional<Output<String>> matchRules() {
        return Optional.ofNullable(this.matchRules);
    }

    /**
     * The name of the policy. The name must be unique
     * 
     */
    @Import(name="name")
    private @Nullable Output<String> name;

    /**
     * @return The name of the policy. The name must be unique
     * 
     */
    public Optional<Output<String>> name() {
        return Optional.ofNullable(this.name);
    }

    /**
     * The version number of the policy
     * 
     */
    @Import(name="version")
    private @Nullable Output<Integer> version;

    /**
     * @return The version number of the policy
     * 
     */
    public Optional<Output<Integer>> version() {
        return Optional.ofNullable(this.version);
    }

    /**
     * A JSON encoded list of warnings
     * 
     */
    @Import(name="warnings")
    private @Nullable Output<String> warnings;

    /**
     * @return A JSON encoded list of warnings
     * 
     */
    public Optional<Output<String>> warnings() {
        return Optional.ofNullable(this.warnings);
    }

    private CloudletsPolicyState() {}

    private CloudletsPolicyState(CloudletsPolicyState $) {
        this.cloudletCode = $.cloudletCode;
        this.cloudletId = $.cloudletId;
        this.description = $.description;
        this.groupId = $.groupId;
        this.matchRuleFormat = $.matchRuleFormat;
        this.matchRules = $.matchRules;
        this.name = $.name;
        this.version = $.version;
        this.warnings = $.warnings;
    }

    public static Builder builder() {
        return new Builder();
    }
    public static Builder builder(CloudletsPolicyState defaults) {
        return new Builder(defaults);
    }

    public static final class Builder {
        private CloudletsPolicyState $;

        public Builder() {
            $ = new CloudletsPolicyState();
        }

        public Builder(CloudletsPolicyState defaults) {
            $ = new CloudletsPolicyState(Objects.requireNonNull(defaults));
        }

        /**
         * @param cloudletCode Code for the type of Cloudlet (ALB, AP, AS, CD, ER, FR, IG, or VP)
         * 
         * @return builder
         * 
         */
        public Builder cloudletCode(@Nullable Output<String> cloudletCode) {
            $.cloudletCode = cloudletCode;
            return this;
        }

        /**
         * @param cloudletCode Code for the type of Cloudlet (ALB, AP, AS, CD, ER, FR, IG, or VP)
         * 
         * @return builder
         * 
         */
        public Builder cloudletCode(String cloudletCode) {
            return cloudletCode(Output.of(cloudletCode));
        }

        /**
         * @param cloudletId An integer that corresponds to a Cloudlets policy type (0 or 9)
         * 
         * @return builder
         * 
         */
        public Builder cloudletId(@Nullable Output<Integer> cloudletId) {
            $.cloudletId = cloudletId;
            return this;
        }

        /**
         * @param cloudletId An integer that corresponds to a Cloudlets policy type (0 or 9)
         * 
         * @return builder
         * 
         */
        public Builder cloudletId(Integer cloudletId) {
            return cloudletId(Output.of(cloudletId));
        }

        /**
         * @param description The description of this specific policy
         * 
         * @return builder
         * 
         */
        public Builder description(@Nullable Output<String> description) {
            $.description = description;
            return this;
        }

        /**
         * @param description The description of this specific policy
         * 
         * @return builder
         * 
         */
        public Builder description(String description) {
            return description(Output.of(description));
        }

        /**
         * @param groupId Defines the group association for the policy. You must have edit privileges for the group
         * 
         * @return builder
         * 
         */
        public Builder groupId(@Nullable Output<String> groupId) {
            $.groupId = groupId;
            return this;
        }

        /**
         * @param groupId Defines the group association for the policy. You must have edit privileges for the group
         * 
         * @return builder
         * 
         */
        public Builder groupId(String groupId) {
            return groupId(Output.of(groupId));
        }

        /**
         * @param matchRuleFormat The version of the Cloudlet specific matchRules
         * 
         * @return builder
         * 
         */
        public Builder matchRuleFormat(@Nullable Output<String> matchRuleFormat) {
            $.matchRuleFormat = matchRuleFormat;
            return this;
        }

        /**
         * @param matchRuleFormat The version of the Cloudlet specific matchRules
         * 
         * @return builder
         * 
         */
        public Builder matchRuleFormat(String matchRuleFormat) {
            return matchRuleFormat(Output.of(matchRuleFormat));
        }

        /**
         * @param matchRules A JSON structure that defines the rules for this policy
         * 
         * @return builder
         * 
         */
        public Builder matchRules(@Nullable Output<String> matchRules) {
            $.matchRules = matchRules;
            return this;
        }

        /**
         * @param matchRules A JSON structure that defines the rules for this policy
         * 
         * @return builder
         * 
         */
        public Builder matchRules(String matchRules) {
            return matchRules(Output.of(matchRules));
        }

        /**
         * @param name The name of the policy. The name must be unique
         * 
         * @return builder
         * 
         */
        public Builder name(@Nullable Output<String> name) {
            $.name = name;
            return this;
        }

        /**
         * @param name The name of the policy. The name must be unique
         * 
         * @return builder
         * 
         */
        public Builder name(String name) {
            return name(Output.of(name));
        }

        /**
         * @param version The version number of the policy
         * 
         * @return builder
         * 
         */
        public Builder version(@Nullable Output<Integer> version) {
            $.version = version;
            return this;
        }

        /**
         * @param version The version number of the policy
         * 
         * @return builder
         * 
         */
        public Builder version(Integer version) {
            return version(Output.of(version));
        }

        /**
         * @param warnings A JSON encoded list of warnings
         * 
         * @return builder
         * 
         */
        public Builder warnings(@Nullable Output<String> warnings) {
            $.warnings = warnings;
            return this;
        }

        /**
         * @param warnings A JSON encoded list of warnings
         * 
         * @return builder
         * 
         */
        public Builder warnings(String warnings) {
            return warnings(Output.of(warnings));
        }

        public CloudletsPolicyState build() {
            return $;
        }
    }

}
