// *** WARNING: this file was generated by test. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***

package com.pulumi.akamai.inputs;

import com.pulumi.akamai.inputs.EdgeKvInitialDataArgs;
import com.pulumi.core.Output;
import com.pulumi.core.annotations.Import;
import java.lang.Integer;
import java.lang.String;
import java.util.List;
import java.util.Objects;
import java.util.Optional;
import javax.annotation.Nullable;


public final class EdgeKvState extends com.pulumi.resources.ResourceArgs {

    public static final EdgeKvState Empty = new EdgeKvState();

    /**
     * Storage location for data
     * 
     */
    @Import(name="geoLocation")
    private @Nullable Output<String> geoLocation;

    /**
     * @return Storage location for data
     * 
     */
    public Optional<Output<String>> geoLocation() {
        return Optional.ofNullable(this.geoLocation);
    }

    /**
     * Namespace ACC group ID. It will be used in EdgeKV API v2. Not updatable.
     * 
     */
    @Import(name="groupId")
    private @Nullable Output<Integer> groupId;

    /**
     * @return Namespace ACC group ID. It will be used in EdgeKV API v2. Not updatable.
     * 
     */
    public Optional<Output<Integer>> groupId() {
        return Optional.ofNullable(this.groupId);
    }

    /**
     * List of pairs to initialize the namespace. Just meaningful for creation, updates will be ignored.
     * 
     * @deprecated
     * The attribute &#39;initial_data&#39; has been deprecated. To manage edgeKV items use &#39;akamai_edgekv_group_items&#39; resource instead.
     * 
     */
    @Deprecated /* The attribute 'initial_data' has been deprecated. To manage edgeKV items use 'akamai_edgekv_group_items' resource instead. */
    @Import(name="initialDatas")
    private @Nullable Output<List<EdgeKvInitialDataArgs>> initialDatas;

    /**
     * @return List of pairs to initialize the namespace. Just meaningful for creation, updates will be ignored.
     * 
     * @deprecated
     * The attribute &#39;initial_data&#39; has been deprecated. To manage edgeKV items use &#39;akamai_edgekv_group_items&#39; resource instead.
     * 
     */
    @Deprecated /* The attribute 'initial_data' has been deprecated. To manage edgeKV items use 'akamai_edgekv_group_items' resource instead. */
    public Optional<Output<List<EdgeKvInitialDataArgs>>> initialDatas() {
        return Optional.ofNullable(this.initialDatas);
    }

    /**
     * Name for the EKV namespace
     * 
     */
    @Import(name="namespaceName")
    private @Nullable Output<String> namespaceName;

    /**
     * @return Name for the EKV namespace
     * 
     */
    public Optional<Output<String>> namespaceName() {
        return Optional.ofNullable(this.namespaceName);
    }

    /**
     * The network on which the namespace will be activated
     * 
     */
    @Import(name="network")
    private @Nullable Output<String> network;

    /**
     * @return The network on which the namespace will be activated
     * 
     */
    public Optional<Output<String>> network() {
        return Optional.ofNullable(this.network);
    }

    /**
     * Retention period for data in this namespace. An update of this value will just affect new EKV items.
     * 
     */
    @Import(name="retentionInSeconds")
    private @Nullable Output<Integer> retentionInSeconds;

    /**
     * @return Retention period for data in this namespace. An update of this value will just affect new EKV items.
     * 
     */
    public Optional<Output<Integer>> retentionInSeconds() {
        return Optional.ofNullable(this.retentionInSeconds);
    }

    private EdgeKvState() {}

    private EdgeKvState(EdgeKvState $) {
        this.geoLocation = $.geoLocation;
        this.groupId = $.groupId;
        this.initialDatas = $.initialDatas;
        this.namespaceName = $.namespaceName;
        this.network = $.network;
        this.retentionInSeconds = $.retentionInSeconds;
    }

    public static Builder builder() {
        return new Builder();
    }
    public static Builder builder(EdgeKvState defaults) {
        return new Builder(defaults);
    }

    public static final class Builder {
        private EdgeKvState $;

        public Builder() {
            $ = new EdgeKvState();
        }

        public Builder(EdgeKvState defaults) {
            $ = new EdgeKvState(Objects.requireNonNull(defaults));
        }

        /**
         * @param geoLocation Storage location for data
         * 
         * @return builder
         * 
         */
        public Builder geoLocation(@Nullable Output<String> geoLocation) {
            $.geoLocation = geoLocation;
            return this;
        }

        /**
         * @param geoLocation Storage location for data
         * 
         * @return builder
         * 
         */
        public Builder geoLocation(String geoLocation) {
            return geoLocation(Output.of(geoLocation));
        }

        /**
         * @param groupId Namespace ACC group ID. It will be used in EdgeKV API v2. Not updatable.
         * 
         * @return builder
         * 
         */
        public Builder groupId(@Nullable Output<Integer> groupId) {
            $.groupId = groupId;
            return this;
        }

        /**
         * @param groupId Namespace ACC group ID. It will be used in EdgeKV API v2. Not updatable.
         * 
         * @return builder
         * 
         */
        public Builder groupId(Integer groupId) {
            return groupId(Output.of(groupId));
        }

        /**
         * @param initialDatas List of pairs to initialize the namespace. Just meaningful for creation, updates will be ignored.
         * 
         * @return builder
         * 
         * @deprecated
         * The attribute &#39;initial_data&#39; has been deprecated. To manage edgeKV items use &#39;akamai_edgekv_group_items&#39; resource instead.
         * 
         */
        @Deprecated /* The attribute 'initial_data' has been deprecated. To manage edgeKV items use 'akamai_edgekv_group_items' resource instead. */
        public Builder initialDatas(@Nullable Output<List<EdgeKvInitialDataArgs>> initialDatas) {
            $.initialDatas = initialDatas;
            return this;
        }

        /**
         * @param initialDatas List of pairs to initialize the namespace. Just meaningful for creation, updates will be ignored.
         * 
         * @return builder
         * 
         * @deprecated
         * The attribute &#39;initial_data&#39; has been deprecated. To manage edgeKV items use &#39;akamai_edgekv_group_items&#39; resource instead.
         * 
         */
        @Deprecated /* The attribute 'initial_data' has been deprecated. To manage edgeKV items use 'akamai_edgekv_group_items' resource instead. */
        public Builder initialDatas(List<EdgeKvInitialDataArgs> initialDatas) {
            return initialDatas(Output.of(initialDatas));
        }

        /**
         * @param initialDatas List of pairs to initialize the namespace. Just meaningful for creation, updates will be ignored.
         * 
         * @return builder
         * 
         * @deprecated
         * The attribute &#39;initial_data&#39; has been deprecated. To manage edgeKV items use &#39;akamai_edgekv_group_items&#39; resource instead.
         * 
         */
        @Deprecated /* The attribute 'initial_data' has been deprecated. To manage edgeKV items use 'akamai_edgekv_group_items' resource instead. */
        public Builder initialDatas(EdgeKvInitialDataArgs... initialDatas) {
            return initialDatas(List.of(initialDatas));
        }

        /**
         * @param namespaceName Name for the EKV namespace
         * 
         * @return builder
         * 
         */
        public Builder namespaceName(@Nullable Output<String> namespaceName) {
            $.namespaceName = namespaceName;
            return this;
        }

        /**
         * @param namespaceName Name for the EKV namespace
         * 
         * @return builder
         * 
         */
        public Builder namespaceName(String namespaceName) {
            return namespaceName(Output.of(namespaceName));
        }

        /**
         * @param network The network on which the namespace will be activated
         * 
         * @return builder
         * 
         */
        public Builder network(@Nullable Output<String> network) {
            $.network = network;
            return this;
        }

        /**
         * @param network The network on which the namespace will be activated
         * 
         * @return builder
         * 
         */
        public Builder network(String network) {
            return network(Output.of(network));
        }

        /**
         * @param retentionInSeconds Retention period for data in this namespace. An update of this value will just affect new EKV items.
         * 
         * @return builder
         * 
         */
        public Builder retentionInSeconds(@Nullable Output<Integer> retentionInSeconds) {
            $.retentionInSeconds = retentionInSeconds;
            return this;
        }

        /**
         * @param retentionInSeconds Retention period for data in this namespace. An update of this value will just affect new EKV items.
         * 
         * @return builder
         * 
         */
        public Builder retentionInSeconds(Integer retentionInSeconds) {
            return retentionInSeconds(Output.of(retentionInSeconds));
        }

        public EdgeKvState build() {
            return $;
        }
    }

}
