// *** WARNING: this file was generated by test. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***

package com.pulumi.akamai.inputs;

import com.pulumi.core.Output;
import com.pulumi.core.annotations.Import;
import java.lang.Integer;
import java.lang.String;
import java.util.List;
import java.util.Objects;
import java.util.Optional;
import javax.annotation.Nullable;


public final class NetworkListActivationsState extends com.pulumi.resources.ResourceArgs {

    public static final NetworkListActivationsState Empty = new NetworkListActivationsState();

    /**
     * The Akamai network on which the list is activated: STAGING or PRODUCTION
     * 
     */
    @Import(name="network")
    private @Nullable Output<String> network;

    /**
     * @return The Akamai network on which the list is activated: STAGING or PRODUCTION
     * 
     */
    public Optional<Output<String>> network() {
        return Optional.ofNullable(this.network);
    }

    /**
     * Unique identifier of the network list
     * 
     */
    @Import(name="networkListId")
    private @Nullable Output<String> networkListId;

    /**
     * @return Unique identifier of the network list
     * 
     */
    public Optional<Output<String>> networkListId() {
        return Optional.ofNullable(this.networkListId);
    }

    /**
     * Descriptive text to accompany the activation
     * 
     */
    @Import(name="notes")
    private @Nullable Output<String> notes;

    /**
     * @return Descriptive text to accompany the activation
     * 
     */
    public Optional<Output<String>> notes() {
        return Optional.ofNullable(this.notes);
    }

    /**
     * List of email addresses of Control Center users who receive an email when activation of this list is complete
     * 
     */
    @Import(name="notificationEmails")
    private @Nullable Output<List<String>> notificationEmails;

    /**
     * @return List of email addresses of Control Center users who receive an email when activation of this list is complete
     * 
     */
    public Optional<Output<List<String>>> notificationEmails() {
        return Optional.ofNullable(this.notificationEmails);
    }

    /**
     * This network list&#39;s current activation status in the environment specified by the &#34;network&#34; attribute
     * 
     */
    @Import(name="status")
    private @Nullable Output<String> status;

    /**
     * @return This network list&#39;s current activation status in the environment specified by the &#34;network&#34; attribute
     * 
     */
    public Optional<Output<String>> status() {
        return Optional.ofNullable(this.status);
    }

    /**
     * Identifies the sync point of the network list to be activated
     * 
     */
    @Import(name="syncPoint")
    private @Nullable Output<Integer> syncPoint;

    /**
     * @return Identifies the sync point of the network list to be activated
     * 
     */
    public Optional<Output<Integer>> syncPoint() {
        return Optional.ofNullable(this.syncPoint);
    }

    private NetworkListActivationsState() {}

    private NetworkListActivationsState(NetworkListActivationsState $) {
        this.network = $.network;
        this.networkListId = $.networkListId;
        this.notes = $.notes;
        this.notificationEmails = $.notificationEmails;
        this.status = $.status;
        this.syncPoint = $.syncPoint;
    }

    public static Builder builder() {
        return new Builder();
    }
    public static Builder builder(NetworkListActivationsState defaults) {
        return new Builder(defaults);
    }

    public static final class Builder {
        private NetworkListActivationsState $;

        public Builder() {
            $ = new NetworkListActivationsState();
        }

        public Builder(NetworkListActivationsState defaults) {
            $ = new NetworkListActivationsState(Objects.requireNonNull(defaults));
        }

        /**
         * @param network The Akamai network on which the list is activated: STAGING or PRODUCTION
         * 
         * @return builder
         * 
         */
        public Builder network(@Nullable Output<String> network) {
            $.network = network;
            return this;
        }

        /**
         * @param network The Akamai network on which the list is activated: STAGING or PRODUCTION
         * 
         * @return builder
         * 
         */
        public Builder network(String network) {
            return network(Output.of(network));
        }

        /**
         * @param networkListId Unique identifier of the network list
         * 
         * @return builder
         * 
         */
        public Builder networkListId(@Nullable Output<String> networkListId) {
            $.networkListId = networkListId;
            return this;
        }

        /**
         * @param networkListId Unique identifier of the network list
         * 
         * @return builder
         * 
         */
        public Builder networkListId(String networkListId) {
            return networkListId(Output.of(networkListId));
        }

        /**
         * @param notes Descriptive text to accompany the activation
         * 
         * @return builder
         * 
         */
        public Builder notes(@Nullable Output<String> notes) {
            $.notes = notes;
            return this;
        }

        /**
         * @param notes Descriptive text to accompany the activation
         * 
         * @return builder
         * 
         */
        public Builder notes(String notes) {
            return notes(Output.of(notes));
        }

        /**
         * @param notificationEmails List of email addresses of Control Center users who receive an email when activation of this list is complete
         * 
         * @return builder
         * 
         */
        public Builder notificationEmails(@Nullable Output<List<String>> notificationEmails) {
            $.notificationEmails = notificationEmails;
            return this;
        }

        /**
         * @param notificationEmails List of email addresses of Control Center users who receive an email when activation of this list is complete
         * 
         * @return builder
         * 
         */
        public Builder notificationEmails(List<String> notificationEmails) {
            return notificationEmails(Output.of(notificationEmails));
        }

        /**
         * @param notificationEmails List of email addresses of Control Center users who receive an email when activation of this list is complete
         * 
         * @return builder
         * 
         */
        public Builder notificationEmails(String... notificationEmails) {
            return notificationEmails(List.of(notificationEmails));
        }

        /**
         * @param status This network list&#39;s current activation status in the environment specified by the &#34;network&#34; attribute
         * 
         * @return builder
         * 
         */
        public Builder status(@Nullable Output<String> status) {
            $.status = status;
            return this;
        }

        /**
         * @param status This network list&#39;s current activation status in the environment specified by the &#34;network&#34; attribute
         * 
         * @return builder
         * 
         */
        public Builder status(String status) {
            return status(Output.of(status));
        }

        /**
         * @param syncPoint Identifies the sync point of the network list to be activated
         * 
         * @return builder
         * 
         */
        public Builder syncPoint(@Nullable Output<Integer> syncPoint) {
            $.syncPoint = syncPoint;
            return this;
        }

        /**
         * @param syncPoint Identifies the sync point of the network list to be activated
         * 
         * @return builder
         * 
         */
        public Builder syncPoint(Integer syncPoint) {
            return syncPoint(Output.of(syncPoint));
        }

        public NetworkListActivationsState build() {
            return $;
        }
    }

}
