// *** WARNING: this file was generated by test. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***

package com.pulumi.akamai.inputs;

import com.pulumi.akamai.inputs.PropertyHostnameArgs;
import com.pulumi.akamai.inputs.PropertyRuleErrorArgs;
import com.pulumi.core.Output;
import com.pulumi.core.annotations.Import;
import java.lang.Integer;
import java.lang.String;
import java.util.List;
import java.util.Objects;
import java.util.Optional;
import javax.annotation.Nullable;


public final class PropertyState extends com.pulumi.resources.ResourceArgs {

    public static final PropertyState Empty = new PropertyState();

    /**
     * Contract ID to be assigned to the Property
     * 
     */
    @Import(name="contractId")
    private @Nullable Output<String> contractId;

    /**
     * @return Contract ID to be assigned to the Property
     * 
     */
    public Optional<Output<String>> contractId() {
        return Optional.ofNullable(this.contractId);
    }

    /**
     * Group ID to be assigned to the Property
     * 
     */
    @Import(name="groupId")
    private @Nullable Output<String> groupId;

    /**
     * @return Group ID to be assigned to the Property
     * 
     */
    public Optional<Output<String>> groupId() {
        return Optional.ofNullable(this.groupId);
    }

    @Import(name="hostnames")
    private @Nullable Output<List<PropertyHostnameArgs>> hostnames;

    public Optional<Output<List<PropertyHostnameArgs>>> hostnames() {
        return Optional.ofNullable(this.hostnames);
    }

    /**
     * Property&#39;s current latest version number
     * 
     */
    @Import(name="latestVersion")
    private @Nullable Output<Integer> latestVersion;

    /**
     * @return Property&#39;s current latest version number
     * 
     */
    public Optional<Output<Integer>> latestVersion() {
        return Optional.ofNullable(this.latestVersion);
    }

    /**
     * Name to give to the Property (must be unique)
     * 
     */
    @Import(name="name")
    private @Nullable Output<String> name;

    /**
     * @return Name to give to the Property (must be unique)
     * 
     */
    public Optional<Output<String>> name() {
        return Optional.ofNullable(this.name);
    }

    /**
     * Product ID to be assigned to the Property
     * 
     */
    @Import(name="productId")
    private @Nullable Output<String> productId;

    /**
     * @return Product ID to be assigned to the Property
     * 
     */
    public Optional<Output<String>> productId() {
        return Optional.ofNullable(this.productId);
    }

    /**
     * Property&#39;s version currently activated in production (zero when not active in production)
     * 
     */
    @Import(name="productionVersion")
    private @Nullable Output<Integer> productionVersion;

    /**
     * @return Property&#39;s version currently activated in production (zero when not active in production)
     * 
     */
    public Optional<Output<Integer>> productionVersion() {
        return Optional.ofNullable(this.productionVersion);
    }

    /**
     * Required property&#39;s version to be read
     * 
     */
    @Import(name="readVersion")
    private @Nullable Output<Integer> readVersion;

    /**
     * @return Required property&#39;s version to be read
     * 
     */
    public Optional<Output<Integer>> readVersion() {
        return Optional.ofNullable(this.readVersion);
    }

    @Import(name="ruleErrors")
    private @Nullable Output<List<PropertyRuleErrorArgs>> ruleErrors;

    public Optional<Output<List<PropertyRuleErrorArgs>>> ruleErrors() {
        return Optional.ofNullable(this.ruleErrors);
    }

    /**
     * Specify the rule format version (defaults to latest version available when created)
     * 
     */
    @Import(name="ruleFormat")
    private @Nullable Output<String> ruleFormat;

    /**
     * @return Specify the rule format version (defaults to latest version available when created)
     * 
     */
    public Optional<Output<String>> ruleFormat() {
        return Optional.ofNullable(this.ruleFormat);
    }

    /**
     * Property Rules as JSON
     * 
     */
    @Import(name="rules")
    private @Nullable Output<String> rules;

    /**
     * @return Property Rules as JSON
     * 
     */
    public Optional<Output<String>> rules() {
        return Optional.ofNullable(this.rules);
    }

    /**
     * Property&#39;s version currently activated in staging (zero when not active in staging)
     * 
     */
    @Import(name="stagingVersion")
    private @Nullable Output<Integer> stagingVersion;

    /**
     * @return Property&#39;s version currently activated in staging (zero when not active in staging)
     * 
     */
    public Optional<Output<Integer>> stagingVersion() {
        return Optional.ofNullable(this.stagingVersion);
    }

    private PropertyState() {}

    private PropertyState(PropertyState $) {
        this.contractId = $.contractId;
        this.groupId = $.groupId;
        this.hostnames = $.hostnames;
        this.latestVersion = $.latestVersion;
        this.name = $.name;
        this.productId = $.productId;
        this.productionVersion = $.productionVersion;
        this.readVersion = $.readVersion;
        this.ruleErrors = $.ruleErrors;
        this.ruleFormat = $.ruleFormat;
        this.rules = $.rules;
        this.stagingVersion = $.stagingVersion;
    }

    public static Builder builder() {
        return new Builder();
    }
    public static Builder builder(PropertyState defaults) {
        return new Builder(defaults);
    }

    public static final class Builder {
        private PropertyState $;

        public Builder() {
            $ = new PropertyState();
        }

        public Builder(PropertyState defaults) {
            $ = new PropertyState(Objects.requireNonNull(defaults));
        }

        /**
         * @param contractId Contract ID to be assigned to the Property
         * 
         * @return builder
         * 
         */
        public Builder contractId(@Nullable Output<String> contractId) {
            $.contractId = contractId;
            return this;
        }

        /**
         * @param contractId Contract ID to be assigned to the Property
         * 
         * @return builder
         * 
         */
        public Builder contractId(String contractId) {
            return contractId(Output.of(contractId));
        }

        /**
         * @param groupId Group ID to be assigned to the Property
         * 
         * @return builder
         * 
         */
        public Builder groupId(@Nullable Output<String> groupId) {
            $.groupId = groupId;
            return this;
        }

        /**
         * @param groupId Group ID to be assigned to the Property
         * 
         * @return builder
         * 
         */
        public Builder groupId(String groupId) {
            return groupId(Output.of(groupId));
        }

        public Builder hostnames(@Nullable Output<List<PropertyHostnameArgs>> hostnames) {
            $.hostnames = hostnames;
            return this;
        }

        public Builder hostnames(List<PropertyHostnameArgs> hostnames) {
            return hostnames(Output.of(hostnames));
        }

        public Builder hostnames(PropertyHostnameArgs... hostnames) {
            return hostnames(List.of(hostnames));
        }

        /**
         * @param latestVersion Property&#39;s current latest version number
         * 
         * @return builder
         * 
         */
        public Builder latestVersion(@Nullable Output<Integer> latestVersion) {
            $.latestVersion = latestVersion;
            return this;
        }

        /**
         * @param latestVersion Property&#39;s current latest version number
         * 
         * @return builder
         * 
         */
        public Builder latestVersion(Integer latestVersion) {
            return latestVersion(Output.of(latestVersion));
        }

        /**
         * @param name Name to give to the Property (must be unique)
         * 
         * @return builder
         * 
         */
        public Builder name(@Nullable Output<String> name) {
            $.name = name;
            return this;
        }

        /**
         * @param name Name to give to the Property (must be unique)
         * 
         * @return builder
         * 
         */
        public Builder name(String name) {
            return name(Output.of(name));
        }

        /**
         * @param productId Product ID to be assigned to the Property
         * 
         * @return builder
         * 
         */
        public Builder productId(@Nullable Output<String> productId) {
            $.productId = productId;
            return this;
        }

        /**
         * @param productId Product ID to be assigned to the Property
         * 
         * @return builder
         * 
         */
        public Builder productId(String productId) {
            return productId(Output.of(productId));
        }

        /**
         * @param productionVersion Property&#39;s version currently activated in production (zero when not active in production)
         * 
         * @return builder
         * 
         */
        public Builder productionVersion(@Nullable Output<Integer> productionVersion) {
            $.productionVersion = productionVersion;
            return this;
        }

        /**
         * @param productionVersion Property&#39;s version currently activated in production (zero when not active in production)
         * 
         * @return builder
         * 
         */
        public Builder productionVersion(Integer productionVersion) {
            return productionVersion(Output.of(productionVersion));
        }

        /**
         * @param readVersion Required property&#39;s version to be read
         * 
         * @return builder
         * 
         */
        public Builder readVersion(@Nullable Output<Integer> readVersion) {
            $.readVersion = readVersion;
            return this;
        }

        /**
         * @param readVersion Required property&#39;s version to be read
         * 
         * @return builder
         * 
         */
        public Builder readVersion(Integer readVersion) {
            return readVersion(Output.of(readVersion));
        }

        public Builder ruleErrors(@Nullable Output<List<PropertyRuleErrorArgs>> ruleErrors) {
            $.ruleErrors = ruleErrors;
            return this;
        }

        public Builder ruleErrors(List<PropertyRuleErrorArgs> ruleErrors) {
            return ruleErrors(Output.of(ruleErrors));
        }

        public Builder ruleErrors(PropertyRuleErrorArgs... ruleErrors) {
            return ruleErrors(List.of(ruleErrors));
        }

        /**
         * @param ruleFormat Specify the rule format version (defaults to latest version available when created)
         * 
         * @return builder
         * 
         */
        public Builder ruleFormat(@Nullable Output<String> ruleFormat) {
            $.ruleFormat = ruleFormat;
            return this;
        }

        /**
         * @param ruleFormat Specify the rule format version (defaults to latest version available when created)
         * 
         * @return builder
         * 
         */
        public Builder ruleFormat(String ruleFormat) {
            return ruleFormat(Output.of(ruleFormat));
        }

        /**
         * @param rules Property Rules as JSON
         * 
         * @return builder
         * 
         */
        public Builder rules(@Nullable Output<String> rules) {
            $.rules = rules;
            return this;
        }

        /**
         * @param rules Property Rules as JSON
         * 
         * @return builder
         * 
         */
        public Builder rules(String rules) {
            return rules(Output.of(rules));
        }

        /**
         * @param stagingVersion Property&#39;s version currently activated in staging (zero when not active in staging)
         * 
         * @return builder
         * 
         */
        public Builder stagingVersion(@Nullable Output<Integer> stagingVersion) {
            $.stagingVersion = stagingVersion;
            return this;
        }

        /**
         * @param stagingVersion Property&#39;s version currently activated in staging (zero when not active in staging)
         * 
         * @return builder
         * 
         */
        public Builder stagingVersion(Integer stagingVersion) {
            return stagingVersion(Output.of(stagingVersion));
        }

        public PropertyState build() {
            return $;
        }
    }

}
