// *** WARNING: this file was generated by test. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***

package com.pulumi.kubernetes;

import com.pulumi.core.Output;
import com.pulumi.core.annotations.Import;
import com.pulumi.core.internal.Codegen;
import com.pulumi.kubernetes.inputs.KubeClientSettingsArgs;
import java.lang.String;
import java.util.Objects;
import java.util.Optional;
import javax.annotation.Nullable;


public final class ProviderArgs extends com.pulumi.resources.ResourceArgs {

    public static final ProviderArgs Empty = new ProviderArgs();

    /**
     * Options for tuning the Kubernetes client used by a Provider.
     * 
     */
    @Import(name="kubeClientSettings", json=true)
    private @Nullable Output<KubeClientSettingsArgs> kubeClientSettings;

    /**
     * @return Options for tuning the Kubernetes client used by a Provider.
     * 
     */
    public Optional<Output<KubeClientSettingsArgs>> kubeClientSettings() {
        return Optional.ofNullable(this.kubeClientSettings);
    }

    /**
     * The contents of a kubeconfig file or the path to a kubeconfig file.
     * 
     */
    @Import(name="kubeconfig")
    private @Nullable Output<String> kubeconfig;

    /**
     * @return The contents of a kubeconfig file or the path to a kubeconfig file.
     * 
     */
    public Optional<Output<String>> kubeconfig() {
        return Optional.ofNullable(this.kubeconfig);
    }

    /**
     * If present, the default namespace to use. This flag is ignored for cluster-scoped resources.
     * 
     * A namespace can be specified in multiple places, and the precedence is as follows:
     * 1. `.metadata.namespace` set on the resource.
     * 2. This `namespace` parameter.
     * 3. `namespace` set for the active context in the kubeconfig.
     * 
     */
    @Import(name="namespace")
    private @Nullable Output<String> namespace;

    /**
     * @return If present, the default namespace to use. This flag is ignored for cluster-scoped resources.
     * 
     * A namespace can be specified in multiple places, and the precedence is as follows:
     * 1. `.metadata.namespace` set on the resource.
     * 2. This `namespace` parameter.
     * 3. `namespace` set for the active context in the kubeconfig.
     * 
     */
    public Optional<Output<String>> namespace() {
        return Optional.ofNullable(this.namespace);
    }

    private ProviderArgs() {}

    private ProviderArgs(ProviderArgs $) {
        this.kubeClientSettings = $.kubeClientSettings;
        this.kubeconfig = $.kubeconfig;
        this.namespace = $.namespace;
    }

    public static Builder builder() {
        return new Builder();
    }
    public static Builder builder(ProviderArgs defaults) {
        return new Builder(defaults);
    }

    public static final class Builder {
        private ProviderArgs $;

        public Builder() {
            $ = new ProviderArgs();
        }

        public Builder(ProviderArgs defaults) {
            $ = new ProviderArgs(Objects.requireNonNull(defaults));
        }

        /**
         * @param kubeClientSettings Options for tuning the Kubernetes client used by a Provider.
         * 
         * @return builder
         * 
         */
        public Builder kubeClientSettings(@Nullable Output<KubeClientSettingsArgs> kubeClientSettings) {
            $.kubeClientSettings = kubeClientSettings;
            return this;
        }

        /**
         * @param kubeClientSettings Options for tuning the Kubernetes client used by a Provider.
         * 
         * @return builder
         * 
         */
        public Builder kubeClientSettings(KubeClientSettingsArgs kubeClientSettings) {
            return kubeClientSettings(Output.of(kubeClientSettings));
        }

        /**
         * @param kubeconfig The contents of a kubeconfig file or the path to a kubeconfig file.
         * 
         * @return builder
         * 
         */
        public Builder kubeconfig(@Nullable Output<String> kubeconfig) {
            $.kubeconfig = kubeconfig;
            return this;
        }

        /**
         * @param kubeconfig The contents of a kubeconfig file or the path to a kubeconfig file.
         * 
         * @return builder
         * 
         */
        public Builder kubeconfig(String kubeconfig) {
            return kubeconfig(Output.of(kubeconfig));
        }

        /**
         * @param namespace If present, the default namespace to use. This flag is ignored for cluster-scoped resources.
         * 
         * A namespace can be specified in multiple places, and the precedence is as follows:
         * 1. `.metadata.namespace` set on the resource.
         * 2. This `namespace` parameter.
         * 3. `namespace` set for the active context in the kubeconfig.
         * 
         * @return builder
         * 
         */
        public Builder namespace(@Nullable Output<String> namespace) {
            $.namespace = namespace;
            return this;
        }

        /**
         * @param namespace If present, the default namespace to use. This flag is ignored for cluster-scoped resources.
         * 
         * A namespace can be specified in multiple places, and the precedence is as follows:
         * 1. `.metadata.namespace` set on the resource.
         * 2. This `namespace` parameter.
         * 3. `namespace` set for the active context in the kubeconfig.
         * 
         * @return builder
         * 
         */
        public Builder namespace(String namespace) {
            return namespace(Output.of(namespace));
        }

        public ProviderArgs build() {
            $.kubeconfig = Codegen.stringProp("kubeconfig").output().arg($.kubeconfig).env("KUBECONFIG").getNullable();
            return $;
        }
    }

}
